#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "rpu2kernel4xi.py">
#<abstract4xi abstract = "RPU kernel management"/>
#<refer4xi reference = "kernel4xi.py"/>
#<verify4xi verification = "10" target = "rpu2kernel4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API  
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'RPU2Kernel4Xi',                       # ACK 5.7.1  p157    

            'add2kernel4rpu',                      # ACK               

            'execute2kernel4rpu',                  # ACK 5.8    p169                                             
            'execute2task4rpu',                    # ACK 5.8    p172   
            'execute2nativekernel4rpu',            # ACK 5.8    p174     
            
            'create2kernel4rpu',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram4rpu',         # ACK 5.7.1  p158  
                       
            'delete2kernel4rpu',                   # ACK

            'fetch2kernel4rpu',                    # ACK 
            
            'get2kernelinfo4rpu',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo4rpu',         # ACK 5.7.3  p164  
            'get2kernelarginfo4rpu',               # ACK 5.7.3  p166                                  
            
            'release2kernel4rpu',                  # ACK 5.7.1  p159                                         
            'retain2kernel4rpu',                   # ACK 5.7.1  p159   
 
            'set2kernel4rpu',                      # ACK 
            'set2kernelcallback4rpu',              # ACK 
            'set2kernelarg4rpu',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel4rpu'                     # ACK 

          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi

# -------------------------------------------------------------------------------------------------
# Buffer                           
# -------------------------------------------------------------------------------------------------
from rpu2buffer4xi import get2bufferinfo4rpu

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from rpu2commandqueue4xi import RPU2CommandQueue4Xi
from rpu2commandqueue4xi import create2commandqueue4rpu 
from rpu2commandqueue4xi import flush2commandqueue4rpu
from rpu2commandqueue4xi import finish2commandqueue4rpu
from rpu2commandqueue4xi import get2commandqueueinfo4rpu
from rpu2commandqueue4xi import release2commandqueue4rpu
from rpu2commandqueue4xi import retain2commandqueue4rpu
from rpu2commandqueue4xi import set2commandqueue4rpu
from rpu2commandqueue4xi import trace2commandqueue4rpu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from rpu2context4xi import RPU2Context4Xi 
from rpu2context4xi import create2context4rpu
from rpu2context4xi import get2context4rpu
from rpu2context4xi import release2context4rpu
from rpu2context4xi import retain2context4rpu
from rpu2context4xi import set2context4rpu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from rpu2device4xi import RPU4Xi
from rpu2device4xi import init2rpu4xi 
from rpu2device4xi import set2rpu4xi
from rpu2device4xi import get2rpu4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from rpu2event4xi import RPU2Event4Xi
from rpu2event4xi import create2event4rpu
from rpu2event4xi import get2eventinfo4rpu
from rpu2event4xi import release2event4rpu
from rpu2event4xi import retain2event4rpu
from rpu2event4xi import set2eventcallback4rpu 
from rpu2event4xi import set2event4rpu
from rpu2event4xi import trace2event4rpu
from rpu2event4xi import wait2event4rpu


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Program module                           
# -------------------------------------------------------------------------------------------------
from rpu2program4xi import RPU2Program4Xi
from rpu2program4xi import add2programwithsource4rpu
from rpu2program4xi import add2programwithbinary4rpu
from rpu2program4xi import build2program4rpu
from rpu2program4xi import compile2program4rpu
from rpu2program4xi import create2programwithsource4rpu
from rpu2program4xi import create2programwithbinary4rpu
from rpu2program4xi import delete2programwithsource4rpu
from rpu2program4xi import delete2programwithbinary4rpu
from rpu2program4xi import get2programinfo4rpu
# from rpu2program4xi import get2programbuildinfo4rpu
from rpu2program4xi import link2program4rpu
from rpu2program4xi import release2program4rpu
from rpu2program4xi import retain2program4rpu
from rpu2program4xi import set2programcallback4rpu 
from rpu2program4xi import set2programwithsource4rpu
from rpu2program4xi import set2programwithbinary4rpu
from rpu2program4xi import trace2program4rpu
# from rpu2program4xi import unload2compiler4rpu

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from process4xi import Process4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                         
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global rpu2kernel4xi                                                    # Kernel of RPU
global rpu2build4xi                                                     # Build of RPU
global rpu2compile4xi                                                   # Compile of RPU
global rpu2trace4xi                                                     # TRACE

global fetch2code4rpu                                                   # Fetched code

global import2use4rpu                                                   # Imports of target function for Process4Xi

global kb2fetch4rpu                                                     # Knowledgebase for fetching
global kb2kernel4rpu                                                    # Knowledgebase for kernel   

global folder2lib4rpu                                                   # Folder of RPU library

global profile2fetch                                                       # Profile knowledgebase for fetching
global keys2profile4rpu

global target2function4rpu                                              # Target function for Process4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
temp2rpu = 'rpu'
key2dir = temp2rpu[0]                                                                                               # MORE COMPLICATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4rpu = VersionKB4Xi[key2dir] 

profile2fetch = {}                                                                                                  # PROFILES FOR FETCHING
profile2fetch ['.py']  = 'ACK'                                                                                    
profile2fetch ['.pyc'] = 'ACK'                                                                                    
profile2fetch ['.cpp'] = 'ACK'                                                                                   
profile2fetch ['.exe'] = 'ACK'       
keys2profile4rpu = profile2fetch.keys()

kb2fetch4rpu = {}                                                                                                   # PROGRAMS TO BE FETCHED - ALWAYS DEFINE BOTH SOURCE AND BINARY PAIRS                               
kb2fetch4rpu[1] = folder2lib4rpu + 'rpu2sampler4xi5test.py'                                                         # Python code
kb2fetch4rpu[2] = folder2lib4rpu + '__pycache__//rpu2sampler4xi.cpython-33.pyc'   
kb2fetch4rpu[3] = folder2lib4rpu + 'rpu2dummy4xi5test.cpp'                                                          # C++ code
kb2fetch4rpu[4] = folder2lib4rpu + "bin//rpu2dummy4xi5test.exe"                                                     # C++ binary

# kb2fetch4rpu[1]  = folder2lib4rpu + 'rpu2sampler4xi5test.py'                                                      
# kb2fetch4rpu[2]  = folder2lib4rpu + '__pycache__//rpu2sampler4xi.cpython-33.pyc'                                  
# kb2fetch4rpu[3]  = folder2lib4rpu + 'rpu2image4xi5test.py'
# kb2fetch4rpu[4]  = folder2lib4rpu + '__pycache__//rpu2image4xi.cpython-33.pyc'
# kb2fetch4rpu[5]  = folder2lib4rpu + 'rpu3image4xi5test.py'
# kb2fetch4rpu[6]  = folder2lib4rpu + '__pycache__//rpu3image4xi.cpython-33.pyc'
# kb2fetch4rpu[7]  = folder2lib4rpu + 'rpu2commandqueue4xi5test.py'
# kb2fetch4rpu[8]  = folder2lib4rpu + '__pycache__//rpu2commandqueue4xi.cpython-33.pyc'
# kb2fetch4rpu[9]  = folder2lib4rpu + 'rpu2event4xi5test.py'
# kb2fetch4rpu[10] = folder2lib4rpu + '__pycache__//rpu2event4xi.cpython-33.pyc'
# kb2fetch4rpu[10]  = folder2lib4rpu + 'RPU2kernel4xi5test.py'
# kb2fetch4rpu[11] = folder2lib4rpu + '__pycache__//rpu2program.cpython-33.pyc'

fetch2code4rpu = {}                                                                                                 # reception arena in memory for code

kb2kernel4rpu = {}
kb2kernel4rpu ['.py'] = {}
kb2kernel4rpu ['.py'] ['TAG']            = "<function4xi function ="                                                
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4rpu ['.py'] ['VALUE']          = "rpu2sampler4xi5test" 
kb2kernel4rpu ['.py'] ['ATTRIBUTE']      = 'usage = "' 

kb2kernel4rpu ['.cpp'] = {}
kb2kernel4rpu ['.cpp'] ['TAG']            = "<function4xi function ="                                               
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4rpu ['.cpp'] ['VALUE']          = "rpu2dummy4xi5test" 
kb2kernel4rpu ['.cpp'] ['ATTRIBUTE']      = 'usage = "kernel'                                                       

#"/>

# -------------------------------------------------------------------------------------------------
# Command queue module of RPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2commandqueue4rpu" usage = " importing target function for Process4Xi">
def importcreate2commandqueue4rpu():
   global target2function4rpu
   from rpu2commandqueue4xi import create2commandqueue4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importflush2commandqueue4rpu" usage = " importing target function for Process4Xi">
def importflush2commandqueue4rpu():
   global target2function4rpu
   from rpu2commandqueue4xi import flush2commandqueue4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importfinish2commandqueue4rpu" usage = " importing target function for Process4Xi">
def importfinish2commandqueue4rpu():
   global target2function4rpu
   from rpu2commandqueue4xi import finish2commandqueue4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importget2commandqueueinfo4rpu" usage = " importing target function for Process4Xi">
def importget2commandqueueinfo4rpu():
   global target2function4rpu
   from rpu2commandqueue4xi import get2commandqueueinfo4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importrelease2commandqueue4rpu" usage = " importing target function for Process4Xi">
def importrelease2commandqueue4rpu():
   global target2function4rpu
   from rpu2commandqueue4xi import release2commandqueue4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importretain2commandqueue4rpu" usage = " importing target function for Process4Xi">
def importretain2commandqueue4rpu():
   global target2function4rpu
   from rpu2commandqueue4xi import retain2commandqueue4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importset2commandqueue4rpu" usage = " importing target function for Process4Xi">
def importset2commandqueue4rpu():
   global target2function4rpu
   from rpu2commandqueue4xi import set2commandqueue4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importtrace2commandqueue4rpu" usage = " importing target function for Process4Xi">
def importtrace2commandqueue4rpu():
   global target2function4rpu
   from rpu2commandqueue4xi import trace2commandqueue4rpu as target2function4rpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Context module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2context4rpu" usage = " importing target function for Process4Xi">
def importcreate2context4rpu():
   global target2function4rpu
   from rpu2context4xi import create2context4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importget2context4rpu" usage = " importing target function for Process4Xi">
def importget2context4rpu():
   global target2function4rpu
   from rpu2context4xi import get2context4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importrelease2context4rpu" usage = " importing target function for Process4Xi">
def importrelease2context4rpu():
   global target2function4rpu
   from rpu2context4xi import release2context4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importretain2context4rpu" usage = " importing target function for Process4Xi">
def importretain2context4rpu():
   global target2function4rpu
   from rpu2context4xi import retain2context4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importset2context4rpu" usage = " importing target function for Process4Xi">
def importset2context4rpu():
   global target2function4rpu
   from rpu2context4xi import set2context4rpu as target2function4rpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Device module of RPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importinit2rpu4xi" usage = " importing target function for Process4Xi">
def importinit2rpu4xi():
   global target2function4rpu
   from rpu2device4xi import init2rpu4xi as target2function4rpu 
#</function4xi>
 
#<function4xi function = "importset2rpu4xi" usage = " importing target function for Process4Xi">
def importset2rpu4xi():
   global target2function4rpu
   from rpu2device4xi import set2rpu4xi   as target2function4rpu
#</function4xi>
 
#<function4xi function = "importget2rpu4xi" usage = " importing target function for Process4Xi">
def importget2rpu4xi():
   global target2function4rpu
   from rpu2device4xi import get2rpu4xi   as target2function4rpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Event module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2event4rpu" usage = " importing target function for Process4Xi">
def importcreate2event4rpu():
   global target2function4rpu
   from rpu2event4xi import create2event4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importget2eventinfo4rpu" usage = " importing target function for Process4Xi">
def importget2eventinfo4rpu():
   global target2function4rpu
   from rpu2event4xi import get2eventinfo4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importrelease2event4rpu" usage = " importing target function for Process4Xi">
def importrelease2event4rpu():
   global target2function4rpu
   from rpu2event4xi import release2event4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importretain2event4rpu" usage = " importing target function for Process4Xi">
def importretain2event4rpu():
   global target2function4rpu
   from rpu2event4xi import retain2event4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importset2eventcallback4rpu" usage = " importing target function for Process4Xi">
def importset2eventcallback4rpu():
   global target2function4rpu
   from rpu2event4xi import set2eventcallback4rpu as target2function4rpu 
#</function4xi>
 
#<function4xi function = "importset2event4rpu" usage = " importing target function for Process4Xi">
def importset2event4rpu():
   global target2function4rpu
   from rpu2event4xi import set2event4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importtrace2event4rpu" usage = " importing target function for Process4Xi">
def importtrace2event4rpu():
   global target2function4rpu
   from rpu2event4xi import trace2event4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importwait2event4rpu" usage = " importing target function for Process4Xi">
def importwait2event4rpu():
   global target2function4rpu
   from rpu2event4xi import wait2event4rpu as target2function4rpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# 2D Image module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2image4rpu" usage = " importing target function for Process4Xi">
def importcreate2image4rpu():
   global target2function4rpu
   from rpu2image4xi import create2image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importget2imageinfo4rpu" usage = " importing target function for Process4Xi">
def importget2imageinfo4rpu():
   global target2function4rpu
   from rpu2image4xi import get2imageinfo4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importget2supportedimageformats4rpu" usage = " importing target function for Process4Xi">
def importget2supportedimageformats4rpu():
   global target2function4rpu
   from rpu2image4xi import get2supportedimageformats4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimage4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimage4rpu():
   global target2function4rpu
   from rpu2image4xi import manoeuvre2copyimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimagetobuffer4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimagetobuffer4rpu():
   global target2function4rpu
   from rpu2image4xi import manoeuvre2copyimagetobuffer4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copybuffertoimage4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copybuffertoimage4rpu():
   global target2function4rpu
   from rpu2image4xi import manoeuvre2copybuffertoimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2readimage4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2readimage4rpu():
   global target2function4rpu
   from rpu2image4xi import manoeuvre2readimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2writeimage4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2writeimage4rpu():
   global target2function4rpu
   from rpu2image4xi import manoeuvre2writeimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2mapimage4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2mapimage4rpu():
   global target2function4rpu
   from rpu2image4xi import manoeuvre2mapimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importcopy2image4rpu" usage = " importing target function for Process4Xi">
def importcopy2image4rpu():
   global target2function4rpu
   from rpu2image4xi import copy2image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importcopy2imagetobuffer4rpu" usage = " importing target function for Process4Xi">
def importcopy2imagetobuffer4rpu():
   global target2function4rpu
   from rpu2image4xi import copy2imagetobuffer4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importcopy2buffertoimage4rpu" usage = " importing target function for Process4Xi">
def importcopy2buffertoimage4rpu():
   global target2function4rpu
   from rpu2image4xi import copy2buffertoimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importread2image4rpu" usage = " importing target function for Process4Xi">
def importread2image4rpu():
   global target2function4rpu
   from rpu2image4xi import read2image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmap2image4rpu" usage = " importing target function for Process4Xi">
def importmap2image4rpu():
   global target2function4rpu
   from rpu2image4xi import map2image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importrelease2image4rpu" usage = " importing target function for Process4Xi">
def importrelease2image4rpu():
   global target2function4rpu
   from rpu2image4xi import release2image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importretain2image4rpu" usage = " importing target function for Process4Xi">
def importretain2image4rpu():
   global target2function4rpu
   from rpu2image4xi import retain2image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importset2imagecallback4rpu" usage = " importing target function for Process4Xi">
def importset2imagecallback4rpu():
   global target2function4rpu
   from rpu2image4xi import set2imagecallback4rpu as target2function4rpu 
#</function4xi>
 
#<function4xi function = "importset2image4rpu" usage = " importing target function for Process4Xi">
def importset2image4rpu():
   global target2function4rpu
   from rpu2image4xi import set2image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importtrace2image4rpu" usage = " importing target function for Process4Xi">
def importtrace2image4rpu():
   global target2function4rpu
   from rpu2image4xi import trace2image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importwait2image4rpu" usage = " importing target function for Process4Xi">
def importwait2image4rpu():
   global target2function4rpu
   from rpu2image4xi import wait2image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importwrite2image4rpu" usage = " importing target function for Process4Xi">
def importwrite2image4rpu():
   global target2function4rpu
   from rpu2image4xi import write2image4rpu as target2function4rpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# 3D Image module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate3image4rpu" usage = " importing target function for Process4Xi">
def importcreate3image4rpu():
   global target2function4rpu
   from rpu3image4xi import create3image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importget3imageinfo4rpu" usage = " importing target function for Process4Xi">
def importget3imageinfo4rpu():
   global target2function4rpu
   from rpu3image4xi import get3imageinfo4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importget3supportedimageformats4rpu" usage = " importing target function for Process4Xi">
def importget3supportedimageformats4rpu():
   global target2function4rpu
   from rpu3image4xi import get3supportedimageformats4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimage4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimage4rpu():
   global target2function4rpu
   from rpu3image4xi import manoeuvre3copyimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimagetobuffer4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimagetobuffer4rpu():
   global target2function4rpu
   from rpu3image4xi import manoeuvre3copyimagetobuffer4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copybuffertoimage4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copybuffertoimage4rpu():
   global target2function4rpu
   from rpu3image4xi import manoeuvre3copybuffertoimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3readimage4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3readimage4rpu():
   global target2function4rpu
   from rpu3image4xi import manoeuvre3readimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3writeimage4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3writeimage4rpu():
   global target2function4rpu
   from rpu3image4xi import manoeuvre3writeimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3mapimage4rpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3mapimage4rpu():
   global target2function4rpu
   from rpu3image4xi import manoeuvre3mapimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importcopy3image4rpu" usage = " importing target function for Process4Xi">
def importcopy3image4rpu():
   global target2function4rpu
   from rpu3image4xi import copy3image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importcopy3imagetobuffer4rpu" usage = " importing target function for Process4Xi">
def importcopy3imagetobuffer4rpu():
   global target2function4rpu
   from rpu3image4xi import copy3imagetobuffer4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importcopy3buffertoimage4rpu" usage = " importing target function for Process4Xi">
def importcopy3buffertoimage4rpu():
   global target2function4rpu
   from rpu3image4xi import copy3buffertoimage4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importread3image4rpu" usage = " importing target function for Process4Xi">
def importread3image4rpu():
   global target2function4rpu
   from rpu3image4xi import read3image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importmap3image4rpu" usage = " importing target function for Process4Xi">
def importmap3image4rpu():
   global target2function4rpu
   from rpu3image4xi import map3image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importrelease3image4rpu" usage = " importing target function for Process4Xi">
def importrelease3image4rpu():
   global target2function4rpu
   from rpu3image4xi import release3image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importretain3image4rpu" usage = " importing target function for Process4Xi">
def importretain3image4rpu():
   global target2function4rpu
   from rpu3image4xi import retain3image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importset3imagecallback4rpu" usage = " importing target function for Process4Xi">
def importset3imagecallback4rpu():
   global target2function4rpu
   from rpu3image4xi import set3imagecallback4rpu as target2function4rpu 
#</function4xi>
 
#<function4xi function = "importset3image4rpu" usage = " importing target function for Process4Xi">
def importset3image4rpu():
   global target2function4rpu
   from rpu3image4xi import set3image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importtrace3image4rpu" usage = " importing target function for Process4Xi">
def importtrace3image4rpu():
   global target2function4rpu
   from rpu3image4xi import trace3image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importwait3image4rpu" usage = " importing target function for Process4Xi">
def importwait3image4rpu():
   global target2function4rpu
   from rpu3image4xi import wait3image4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importwrite3image4rpu" usage = " importing target function for Process4Xi">
def importwrite3image4rpu():
   global target2function4rpu
   from rpu3image4xi import write3image4rpu as target2function4rpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Sampler module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2sampler4rpu" usage = " importing target function for Process4Xi">
def importcreate2sampler4rpu():
   global target2function4rpu
   from rpu2sampler4xi import create2sampler4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importget2samplerinfo4rpu" usage = " importing target function for Process4Xi">
def importget2samplerinfo4rpu():
   global target2function4rpu
   from rpu2sampler4xi import get2samplerinfo4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importrelease2sampler4rpu" usage = " importing target function for Process4Xi">
def importrelease2sampler4rpu():
   global target2function4rpu
   from rpu2sampler4xi import release2sampler4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importretain2sampler4rpu" usage = " importing target function for Process4Xi">
def importretain2sampler4rpu():
   global target2function4rpu
   from rpu2sampler4xi import retain2sampler4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importset2samplercallback4rpu" usage = " importing target function for Process4Xi">
def importset2samplercallback4rpu():
   global target2function4rpu
   from rpu2sampler4xi import set2samplercallback4rpu as target2function4rpu 
#</function4xi>
 
#<function4xi function = "importset2sampler4rpu" usage = " importing target function for Process4Xi">
def importset2sampler4rpu():
   global target2function4rpu
   from rpu2sampler4xi import set2sampler4rpu as target2function4rpu
#</function4xi>
 
#<function4xi function = "importtrace2sampler4rpu" usage = " importing target function for Process4Xi">
def importtrace2sampler4rpu():
   global target2function4rpu
   from rpu2sampler4xi import trace2sampler4rpu as target2function4rpu
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
# Program module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2programwithsource4rpu" usage = " importing target function for Process4Xi">
def importcreate2programwithsource4rpu():
   global target2function4rpu
   from rpu2kernel4xi import create2programwithsource4rpu as target2function4rpu
#</function4xi> 

#<function4xi function = "importcreate2programwithbinary4rpu" usage = " importing target function for Process4Xi">
def importcreate2programwithbinary4rpu():
   global target2function4rpu
   from rpu2kernel4xi import create2programwithbinary4rpu as target2function4rpu
#</function4xi> 

#<function4xi function = "importadd2programwithsource4rpu" usage = " importing target function for Process4Xi">
def importadd2programwithsource4rpu():
   global target2function4rpu
   from rpu2kernel4xi import add2programwithsource4rpu as target2function4rpu
#</function4xi> 

#<function4xi function = "importadd2programwithbinary4rpu" usage = " importing target function for Process4Xi">
def importadd2programwithbinary4rpu():
   global target2function4rpu
   from rpu2kernel4xi import add2programwithbinary4rpu as target2function4rpu
#</function4xi>

#<function4xi function = "importbuild2program4rpu" usage = " importing target function for Process4Xi">
def importbuild2program4rpu():
   global target2function4rpu
   from rpu2kernel4xi import build2program4rpu as target2function4rpu
#</function4xi>

#<function4xi function = "importbuild2program4rpu" usage = " importing target function for Process4Xi">
def importbuild2program4rpu():
   global target2function4rpu
   from rpu2kernel4xi import build2program4rpu as target2function4rpu
#</function4xi>

#<function4xi function = "importcompile2program4rpuX" usage = " importing target function for Process4Xi">
def importcompile2program4rpu():
   global target2function4rpu
   from rpu2kernel4xi import compile2program4rpu as target2function4rpu
#</function4xi>

#<function4xi function = "importdelete2programwithsource4rpuX" usage = " importing target function for Process4Xi">
def importdelete2programwithsource4rpu():
   global target2function4rpu
   from rpu2kernel4xi import delete2programwithsource4rpu as target2function4rpu
#</function4xi>    

#<function4xi function = "importdelete2programwithbinary4rpuX" usage = " importing target function for Process4Xi">
def importdelete2programwithbinary4rpu():
   global target2function4rpu
   from rpu2kernel4xi import delete2programwithbinary4rpu as target2function4rpu
#</function4xi>    

#<function4xi function = "importget2programinfo4rpuX" usage = " importing target function for Process4Xi">
def importget2programinfo4rpu():
   global target2function4rpu
   from rpu2kernel4xi import get2programinfo4rpu as target2function4rpu
#</function4xi>    

#<function4xi function = "importlink2program4rpuX" usage = " importing target function for Process4Xi">
def importlink2program4rpu():
   global target2function4rpu
   from rpu2kernel4xi import link2program4rpu as target2function4rpu
#</function4xi>    

#<function4xi function = "importrelease2program4rpuX" usage = " importing target function for Process4Xi">
def importrelease2program4rpu():
   global target2function4rpu
   from rpu2kernel4xi import release2program4rpu as target2function4rpu
#</function4xi>    

#<function4xi function = "importretain2program4rpuX" usage = " importing target function for Process4Xi">
def importretain2program4rpu():
   global target2function4rpu
   from rpu2kernel4xi import retain2program4rpu as target2function4rpu
#</function4xi>    

#<function4xi function = "importset2programcallback4rpuX" usage = " importing target function for Process4Xi">
def importset2programcallback4rpu():
   global target2function4rpu
   from rpu2kernel4xi import set2programcallback4rpu as target2function4rpu
#</function4xi>    

#<function4xi function = "importset2programwithsource4rpuX" usage = " importing target function for Process4Xi">
def importset2programwithsource4rpu():
   global target2function4rpu
   from rpu2kernel4xi import set2programwithsource4rpu as target2function4rpu
#</function4xi>    

#<function4xi function = "importset2programwithbinary4rpuX" usage = " importing target function for Process4Xi">
def importset2programwithbinary4rpu():
   global target2function4rpu
   from rpu2kernel4xi import set2programwithbinary4rpu as target2function4rpu
#</function4xi>    

#<function4xi function = "importtrace2program4rpuX" usage = " importing target function for Process4Xi">
def importtrace2program4rpu():
   global target2function4rpu
   from rpu2kernel4xi import trace2program4rpu as target2function4rpu
#</function4xi>    

# -------------------------------------------------------------------------------------------------
# Test modules of RPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importrpu2commandqueue4xi5test" usage = " importing target function for Process4Xi">
def importrpu2commandqueue4xi5test():
   global target2function4rpu
   from rpu2commandqueue4xi5test import rpu2commandqueue4xi5test as target2function4rpu
#</function4xi> 

#<function4xi function = "importrpu2event4xi5test" usage = " importing target function for Process4Xi">
def importrpu2event4xi5test():
   global target2function4rpu
   from rpu2event4xi5test import rpu2event4xi5test as target2function4rpu
#</function4xi>
 
#<function4xi function = "importrpu2image4xi5test" usage = " importing target function for Process4Xi">
def importrpu2image4xi5test():
   global target2function4rpu
   from rpu2image4xi5test import rpu2image4xi5test as target2function4rpu
#</function4xi>
 
#<function4xi function = "importrpu3image4xi5test" usage = " importing target function for Process4Xi">
def importrpu3image4xi5test():
   global target2function4rpu
   from rpu3image4xi5test import rpu3image4xi5test as target2function4rpu
#</function4xi>
 
#<function4xi function = "importrpu2sampler4xi5test" usage = " importing target function for Process4Xi">
def importrpu2sampler4xi5test():
   global target2function4rpu
   from rpu2sampler4xi5test import rpu2sampler4xi5test as target2function4rpu
#</function4xi>
 
#<function4xi function = "importRPU2kernel4xi5test" usage = " importing target function for Process4Xi">
def importrpu2kernel4xi5test():
   global target2function4rpu
   from rpu2kernel4xi5test import rpu2kernel4xi5test as target2function4rpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Error handler of RPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "handle2error4rpu" usage = " Error handling for importing target function for Process4Xi">
def handle2error4rpu():
   global import2use4rpu
   print ("HANDLE2ERROR4RPU OF RPU2KERNEL4XI.PY: *** FAILED TO IMPORT TARGET FUNCTION ***")
   keys2import4rpu = import2use4rpu.keys()
   for key2import4rpu in keys2import4rpu:
       print(key2import4rpu,import2use4rpu[key2import4rpu]) 
#</function4xi> 


import2use4rpu = {}
# -------------------------------------------------------------------------------------------------
# Command queue module of RPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4rpu["create2commandqueue4rpu"] = importcreate2commandqueue4rpu        
import2use4rpu["flush2commandqueue4rpu"] = importflush2commandqueue4rpu 
import2use4rpu["finish2commandqueue4rpu"] = importfinish2commandqueue4rpu 
import2use4rpu["get2commandqueueinfo4rpu"] = importget2commandqueueinfo4rpu 
import2use4rpu["release2commandqueue4rpu"] = importrelease2commandqueue4rpu 
import2use4rpu["retain2commandqueue4rpu"] = importretain2commandqueue4rpu 
import2use4rpu["set2commandqueue4rpu"] = importset2commandqueue4rpu 
import2use4rpu["trace2commandqueue4rpu"] = importtrace2commandqueue4rpu 

# -------------------------------------------------------------------------------------------------
# Context module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4rpu["create2context4rpu"] = importcreate2context4rpu 
import2use4rpu["get2context4rpu"] = importget2context4rpu 
import2use4rpu["release2context4rpu"] = importrelease2context4rpu 
import2use4rpu["retain2context4rpu"] = importretain2context4rpu 
import2use4rpu["set2context4rpu"] = importset2context4rpu 

# -------------------------------------------------------------------------------------------------
# Device module of RPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4rpu["init2rpu4xi"] = importinit2rpu4xi 
import2use4rpu["set2rpu4xi"] = importset2rpu4xi 
import2use4rpu["get2rpu4xi"] = importget2rpu4xi 

# -------------------------------------------------------------------------------------------------
# Event module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4rpu["create2event4rpu"] = importcreate2event4rpu 
import2use4rpu["get2eventinfo4rpu"] = importget2eventinfo4rpu 
import2use4rpu["release2event4rpu"] = importrelease2event4rpu 
import2use4rpu["retain2event4rpu"] = importretain2event4rpu 
import2use4rpu["set2eventcallback4rpu"] = importset2eventcallback4rpu 
import2use4rpu["set2event4rpu"] = importset2event4rpu 
import2use4rpu["trace2event4rpu"] = importtrace2event4rpu 
import2use4rpu["wait2event4rpu"] = importwait2event4rpu 

# -------------------------------------------------------------------------------------------------
# 2D Image module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4rpu["create2image4rpu"] = importcreate2image4rpu 
import2use4rpu["get2imageinfo4rpu"] = importget2imageinfo4rpu 
import2use4rpu["get2supportedimageformats4rpu"] = importget2supportedimageformats4rpu 
import2use4rpu["manoeuvre2copyimage4rpu"] = importmanoeuvre2copyimage4rpu 
import2use4rpu["manoeuvre2copyimagetobuffer4rpu"] = importmanoeuvre2copyimagetobuffer4rpu 
import2use4rpu["manoeuvre2copybuffertoimage4rpu"] = importmanoeuvre2copybuffertoimage4rpu 
import2use4rpu["manoeuvre2readimage4rpu"] = importmanoeuvre2readimage4rpu 
import2use4rpu["manoeuvre2writeimage4rpu"] = importmanoeuvre2writeimage4rpu 
import2use4rpu["manoeuvre2mapimage4rpu"] = importmanoeuvre2mapimage4rpu 
import2use4rpu["copy2image4rpu"] = importcopy2image4rpu 
import2use4rpu["copy2imagetobuffer4rpu"] = importcopy2imagetobuffer4rpu 
import2use4rpu["copy2buffertoimage4rpu"] = importcopy2buffertoimage4rpu 
import2use4rpu["read2image4rpu"] = importread2image4rpu 
import2use4rpu["map2image4rpu"] = importmap2image4rpu 
import2use4rpu["release2image4rpu"] = importrelease2image4rpu 
import2use4rpu["retain2image4rpu"] = importretain2image4rpu 
import2use4rpu["set2imagecallback4rpu"] = importset2imagecallback4rpu 
import2use4rpu["set2image4rpu"] = importset2image4rpu 
import2use4rpu["trace2image4rpu"] = importtrace2image4rpu 
import2use4rpu["wait2image4rpu"] = importwait2image4rpu 
import2use4rpu["write2image4rpu"] = importwrite2image4rpu 

# -------------------------------------------------------------------------------------------------
# 3D Image module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4rpu["create3image4rpu"] = importcreate3image4rpu 
import2use4rpu["get3imageinfo4rpu"] = importget3imageinfo4rpu 
import2use4rpu["get3supportedimageformats4rpu"] = importget3supportedimageformats4rpu 
import2use4rpu["manoeuvre3copyimage4rpu"] = importmanoeuvre3copyimage4rpu 
import2use4rpu["manoeuvre3copyimagetobuffer4rpu"] = importmanoeuvre3copyimagetobuffer4rpu 
import2use4rpu["manoeuvre3copybuffertoimage4rpu"] = importmanoeuvre3copybuffertoimage4rpu 
import2use4rpu["manoeuvre3readimage4rpu"] = importmanoeuvre3readimage4rpu 
import2use4rpu["manoeuvre3writeimage4rpu"] = importmanoeuvre3writeimage4rpu 
import2use4rpu["manoeuvre3mapimage4rpu"] = importmanoeuvre3mapimage4rpu 
import2use4rpu["copy3image4rpu"] = importcopy3image4rpu 
import2use4rpu["copy3imagetobuffer4rpu"] = importcopy3imagetobuffer4rpu 
import2use4rpu["copy3buffertoimage4rpu"] = importcopy3buffertoimage4rpu 
import2use4rpu["read3image4rpu"] = importread3image4rpu 
import2use4rpu["map3image4rpu"] = importmap3image4rpu 
import2use4rpu["release3image4rpu"] = importrelease3image4rpu 
import2use4rpu["retain3image4rpu"] = importretain3image4rpu 
import2use4rpu["set3imagecallback4rpu"] = importset3imagecallback4rpu 
import2use4rpu["set3image4rpu"] = importset3image4rpu 
import2use4rpu["trace3image4rpu"] = importtrace3image4rpu 
import2use4rpu["wait3image4rpu"] = importwait3image4rpu 
import2use4rpu["write3image4rpu"] = importwrite3image4rpu 

# -------------------------------------------------------------------------------------------------
# Sampler module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4rpu["create2sampler4rpu"] = importcreate2sampler4rpu 
import2use4rpu["get2samplerinfo4rpu"] = importget2samplerinfo4rpu 
import2use4rpu["release2sampler4rpu"] = importrelease2sampler4rpu 
import2use4rpu["retain2sampler4rpu"] = importretain2sampler4rpu 
import2use4rpu["set2samplercallback4rpu"] = importset2samplercallback4rpu 
import2use4rpu["set2sampler4rpu"] = importset2sampler4rpu 
import2use4rpu["trace2sampler4rpu"] = importtrace2sampler4rpu 

# -------------------------------------------------------------------------------------------------
# Program module of RPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4rpu["trace2program4rpu"] = importtrace2program4rpu
import2use4rpu["set2programwithbinary4rpu"] = importset2programwithbinary4rpu
import2use4rpu["set2programwithsource4rpu"] = importset2programwithsource4rpu
import2use4rpu["set2programcallback4rpu"] = importset2programcallback4rpu
import2use4rpu["retain2program4rpu"] = importretain2program4rpu
import2use4rpu["release2program4rpu"] = importrelease2program4rpu
import2use4rpu["link2program4rpu"] = importlink2program4rpu
import2use4rpu["get2programinfo4rpu"] = importget2programinfo4rpu
import2use4rpu["delete2programwithbinary4rpu"] = importdelete2programwithbinary4rpu
import2use4rpu["delete2programwithsource4rpu"] = importdelete2programwithsource4rpu
import2use4rpu["compile2program4rpu"] = importcompile2program4rpu
import2use4rpu["build2program4rpu"] = importbuild2program4rpu
import2use4rpu["build2program4rpu"] = importbuild2program4rpu
import2use4rpu["add2programwithbinary4rpu"] = importadd2programwithbinary4rpu
import2use4rpu["add2programwithsource4rpu"] = importadd2programwithsource4rpu
import2use4rpu["create2programwithbinary4rpu"] = importcreate2programwithbinary4rpu
import2use4rpu["create2programwithsource4rpu"] = importcreate2programwithsource4rpu



# -------------------------------------------------------------------------------------------------
# Test modules of RPU imports for target function                             
# -------------------------------------------------------------------------------------------------
import2use4rpu["rpu2commandqueue4xi5test"] = importrpu2commandqueue4xi5test 
import2use4rpu["rpu2event4xi5test"] = importrpu2event4xi5test 
import2use4rpu["rpu2image4xi5test"] = importrpu2image4xi5test 
import2use4rpu["rpu3image4xi5test"] = importrpu3image4xi5test 
import2use4rpu["rpu2sampler4xi5test"] = importrpu2sampler4xi5test 
import2use4rpu["rpu2kernel4xi5test"] = importrpu2kernel4xi5test 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2kernel4rpu" usage = "
#
#   print('=' *33)          
#   print('(Step 15A/25) OF RPU2KERNEL4XI5TEST - TRYING TO TRACE RPU: ', time4xi())      
#   print('=' *33)      
#   trace2rpu = None
#   try:
#       trace2rpu = trace2kernel4rpu() 
#       print('(Step 15B/25) OF RPU2KERNEL4XI5TEST - TRACE2RPU: ', trace2rpu)  
#       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4rpu-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4rpu', 'METHOD': 'trace2kernel4rpu'} 
#   except:
#       print('(Step 15Z1/25) OF RPU2KERNEL4XI5TEST *** FAILED TO TRACE RPU: ', trace2rpu) 
#      
#">

# -------------------------------------------------------------------------------------------------   
def trace2kernel4rpu(task4trace2rpu=None):  

    '''
    creates callback to rpu2kernel4xi
    '''
    
    global rpu2trace4xi
    global folder2lib4rpu    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2kernel4rpu" 
    method2print = "trace2kernel4rpu"

    message2print = "{(Step 1A/33) started" + "; trace2kernel4rpu-started: " + str(trace2kernel4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                               
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2rpu-to-trace2kernel4rpu: " + str(task4trace2rpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    rpu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2rpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY RPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2rpu = {}                                                                                            
            
        task4trace2rpu['CLASS']   = "trace2kernel4rpu"                                                              # RPUIZE ZPU TRACE!
        task4trace2rpu['METHOD']  = "trace2kernel4rpu" 
        task4trace2rpu['MESSAGE'] = "{(Step 2Z0/33) failed" + "; trace2kernel4rpu-failed " + str(rpu2trace4xi)  + "; time: " + time4xi() + "}"               
  
        
        message2print = "{(Step 2A/33) set" + "; task4trace2rpu-set-by-trace2kernel4rpu to: " + str(task4trace2rpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # PARAMETER GIVEN BY RPUIZED CALLBACK !
    # -----------------------------------------------------------------------------------------          
    message2print = "{(Step 3A/33) try" + "; task4trace2rpu-try-by-trace2kernel4rpu: " + str(task4trace2rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
    # 

    try:
        rpu2trace4xi ['CLASS']  = task4trace2rpu['CLASS']                                                           # RPUIZE RPU TRACE!
        rpu2trace4xi ['METHOD']  = task4trace2rpu['METHOD']
        rpu2trace4xi ['MESSAGE'] = task4trace2rpu['MESSAGE']
        
        message2print = "{(Step 3B/33) set" + "; rpu2trace4xi-set-by-trace2kernel4rpu to: " + str(rpu2trace4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 

        code2ack = code2ack + '3B-'         
    except:
        message2print = "{(Step 3Z1/33) failed" + "; rpu-trace-failed-by-trace2kernel4rpu: " + str(task4trace2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z1-' 
        
    try:
        # =================================
        # SIMULATE RPU TRACE
        # =================================
        class2print   = task4trace2rpu['CLASS']                                                                     # RPUIZE RPU TRACE!
        method2print  = task4trace2rpu['METHOD']
        
        message2print = task4trace2rpu['MESSAGE']
        print4xi(class2print, method2print, message2print)                                                          # RPUIZED TRACE FOR OPENCL CALLBACK!
        # 
        
        
        code2ack = code2ack + '3C-'         
    except:
        class2print = "trace2kernel4rpu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4rpu"   
        message2print = "{(Step 3Z2/33) failed" + "; simulation-of-rpu-trace-failed-by-trace2kernel4rpu: " + str(task4trace2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z2-' 
        
    try:
        # =================================
        # NORMAL TRACE
        # =================================                     
        class2print = "trace2kernel4rpu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4rpu"                
        message2print = "{(Step 3D/33) performed" + "; rpu-trace-performed-by-trace2kernel4rpu: " + str(task4trace2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack = code2ack + '3D-' 
    except:
        message2print = "{(Step 3Z3/33) failed" + "; rpu-trace-failed-by-trace2kernel4rpu: " + str(task4trace2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z3-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; rpu2trace4xi-returning-by-trace2kernel4rpu: " + str(rpu2trace4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return rpu2trace4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2kernel4rpu" usage = "
#
#   response4execute2kernel = execute2kernel4rpu()
#      
#">

# -------------------------------------------------------------------------------------------------   
def execute2kernel4rpu(task4execute2rpu=None):  

    '''
    executes kernel to RPU 
    '''
    global folder2lib4rpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2kernel4rpu" 
    method2print = "execute2kernel4rpu"

    message2print = "{(Step 1A/33) started" + "; execute2kernel4rpu-started: " + str(execute2kernel4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
          
    message2print = "{(Step 1B/33) passed" + "; task4execute2rpu-to-execute2kernel4rpu: " + str(task4execute2rpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                            # 
    # 
    status4execute2rpu = 'CL_SUCCESS'
    
    code2ack  = ' '
    code2nack = ' '    
    
                                                                                                                  #       
    if task4execute2rpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN - BUILD THEM
        # -----------------------------------------------------------------------------------------    
        task4execute2rpu = {}                                                                                            

        message2print = "{(Step 2A/33) set" + "; task4execute2rpu-set-by-execute2kernel4rpu to: " + str(task4execute2rpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------          
    status4execute2rpu = 'CL_SUCCESS'
    message2print = "{(Step 3A/33) set" + "; status4execute2rpu-set-by-execute2kernel4rpu to: " + str(status4execute2rpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; status4execute2rpu-returning-by-execute2kernel4rpu: " + str(status4execute2rpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return status4execute2rpu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelcallback4rpu" usage = "
#
#   print('(Step 14A/700) OF RPU2KERNEL4XI5TEST - TRYING TO SET PROGRAM CALLBACK OF RPU ', time4xi())  
#   try:                               
#       response4setcallback2program = set2kernelcallback4rpu()                                                                                                 
#       print('(Step 14B/700) OF RPU2KERNEL4XI5TEST - SET PROGRAM CALLBACK OF RPU TO: ', response4setcallback2program)   
#       # 
#   except:
#       print('(Step 14Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO SET PROGRAM CALLBACK OF RPU ', time4xi())  
# 
#">

# ------------------------------------------------------------------------------------------------- 
 
def set2kernelcallback4rpu(task4set2kernelcallback=None):

    '''
    registers callback function to rpu2kernel4xi
    '''
    global rpu2kernel4xi
    global folder2lib4rpu  
        
    class2print = "set2kernelcallback4rpu" 
    method2print = "set2kernelcallback4rpu"
    
    message2print = "{(Step 2A/70) started" + "; set2kernelcallback4rpu-started: " + str(set2kernelcallback4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # set2kernelcallback4rpu-started
    
    try:
    
        rpu2kernel4xi ['CALLBACK'] = trace2kernel4rpu
        
        
        message2print = "{(Step 2C/70) returning" + "; callback-of-rpu2kernel4xi-returning-by-set2kernelcallback4rpu: " + str(rpu2kernel4xi ['CALLBACK']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print) 
        # 
        
        return rpu2kernel4xi ['CALLBACK']      
        
    except:
        message2print = "{(Step 2Z1/70) failed" + "; callback2program-failed-by-set2kernelcallback4rpu: " + str(callback2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         

        message2print = "{(Step 2Z2/70) returning" + "; trace2kernel4rpu-returning-by-set2kernelcallback4rpu: " + str(trace2kernel4rpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)      
            
        return trace2kernel4rpu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2task4rpu" usage = "
#
#   try:                               
#       response4execute2task = execute2task4rpu(task4execute2task)
#       print('(Step 99B/700) OF RPU2KERNEL4XI5TEST - BUILT PROGRAM OF RPU DEVICE ', time4xi())
#   except:
#       print('(Step 99Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO EXECUTE PROGRAM OF RPU DEVICE ', time4xi())  
#                 
#">

# -------------------------------------------------------------------------------------------------   
def execute2task4rpu(task4execute2rpu=None):

    '''
    executes  program to RPU 
    '''
    global rpu2execute4xi
    global folder2lib4rpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2task4rpu"
    method2print = "execute2task4rpu" 

    message2print = "{(Step 1A/33) started" + "; execute2task4rpu-started: " + str(execute2task4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # execute2task4rpu-started
    
    
    message2print = "{(Step 1B/33) passed" + "; task4execute2rpu-to-execute2task4rpu: " + str(task4execute2rpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
             
    code2ack  = ' '
    code2nack = ' '

    message2print = "{(Step 1A/70) try" + "; execute-try-by-execute2task4rpu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    try:             
        if task4execute2rpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - EXECUTE TASK TO RPU! 
            # -----------------------------------------------------------------------------------------    
            task4execute2rpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4execute2rpu-initialized-by-execute2task4rpu: " + str(task4execute2rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 
            
            # ---------------------------------------------------------------------------------------------
            # (1) KERNEL REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            program2rpu = {}
            message2print = "{(Step 1A/70) trying" + "; program2rpu-trying-by-create2kernel4rpu: " + str(program2rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                program2rpu = create2kernel4rpu()                                                                     
                
                message2print = "{(Step 1B/70) got" + "; program2rpu-got-by-create2kernel4rpu: " + str(program2rpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                #                 
                code2ack  = code2ack + '1B-'         
            except:
                message2print = "{(Step 1Z/70) failed" + "; program2rpu-failed-by-create2kernel4rpu: " + str(program2rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '1Z-'
                
            task4execute2rpu ['PROGRAM'] = program2rpu
            
            # ---------------------------------------------------------------------------------------------
            # (2) OPTIONS - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            task4execute2task  ['OPTIONS'] = {}
          
            
            # ---------------------------------------------------------------------------------------------
            # (3) CALLBACK - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            function2callback4rpu = trace2kernel4rpu                                                               # CALLBACK FUNCTION FOR RPU
            
            message2print = "{(Step 3A/70) initialized" + "; function2callback4rpu-created-by-execute2task4rpu: " + str(function2callback4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 
            
            code2ack  = code2ack + '3A-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "execute2task4rpu"                                                            # MODULE OF RPUIZED OPENCL MODULE
            args2callback['METHOD']  = "execute2task4rpu"                                                            # FUNCTION OF RPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 3Z1/33) failed" + "; execute2task4rpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR RPUIZED OPENCL TO RETURN    

            message2print = "{(Step 3B/70) initialized" + "; args2callback-created-by-execute2task4rpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 

            code2ack  = code2ack + '3B-'
            
           
            task4execute2rpu['DATA2CALLBACK'] = args2callback                                                       # USER DATA PASSED TO RPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4execute2rpu['FUNCTION2CALLBACK'] = function2callback4rpu                                           # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '3C-'

            
            # ---------------------------------------------------------------------------------------------
            # (4) USERDATA - REQUIRED                         
            # ---------------------------------------------------------------------------------------------
            task4execute2rpu['USERDATA'] = None 
            
            message2print = "{(Step 4A/70) initialized" + "; task4execute2rpu-created-by-execute2task4rpu: " + str(task4execute2rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #
        else:
            pass                                                                  
    except:
        message2print = "{(Step 1Z1/70) yielded" + "; task4execute2rpu-yielded-by-execute2task4rpu: " + str(task4execute2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-'  
                                                                                                 
    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4execute2rpu.keys()        
    message2print = "{(Step 9/70) using" + "; keys2task-using-by-execute2task4rpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 
  
    # ---------------------------------------------------------------------------------------------
    # (Step 10A/70) - CREATE EXECUTE FOR RPU ! 
    # ---------------------------------------------------------------------------------------------    
    rpu2execute4xi = {}                                                                                                                                                                               
    message2print = "{(Step 10A/70) initialized" + "; rpu2execute4xi-initialized-by-execute2task4rpu to: " + str(rpu2execute4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    message2print = "{(Step 11A0/70) try" + "; program-try-by-execute2task4rpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 11A/70) - PROGRAM - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        rpu2execute4xi['PROGRAM'] = task4execute2rpu['PROGRAM']
        
        message2print = "{(Step 11A1/70) initialized" + "; program-created-by-execute2task4rpu: " + str(rpu2execute4xi['PROGRAM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '11A1-'
    except: 
        message2print = "{(Step 11Z1/70) yielded" + "; program-rpu2execute4xi-yielded-by-execute2task4rpu: " + str(rpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '11Z1-' 
           
    message2print = "{(Step 12A0/70) try" + "; options-try-by-execute2task4rpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 12A/70) - OPTIONS - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        rpu2execute4xi['OPTIONS'] = task4execute2rpu['OPTIONS']
        
        message2print = "{(Step 12A1/70) initialized" + "; options-created-by-execute2task4rpu: " + str(rpu2execute4xi['OPTIONS'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '12A1-'
    except: 
        message2print = "{(Step 12Z1/70) yielded" + "; options-rpu2execute4xi-yielded-by-execute2task4rpu: " + str(rpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '12Z1-' 
        
    message2print = "{(Step 13A0/70) try" + "; callback-try-by-execute2task4rpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 13A/70) - CALLBACK - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        rpu2execute4xi['CALLBACK'] = task4execute2rpu['CALLBACK']
        
        message2print = "{(Step 13A1/70) initialized" + "; callback-created-by-execute2task4rpu: " + str(rpu2execute4xi['CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '13A1-'
    except: 
        message2print = "{(Step 13Z1/70) yielded" + "; callback-rpu2execute4xi-yielded-by-execute2task4rpu: " + str(rpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '13Z1-' 
        
    message2print = "{(Step 14A0/70) try" + "; userdata-try-by-execute2task4rpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 14A/70) - USERDATA - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        rpu2execute4xi['USERDATA'] = task4execute2rpu['USERDATA']
        
        message2print = "{(Step 14A1/70) initialized" + "; userdata-created-by-execute2task4rpu: " + str(rpu2execute4xi['USERDATA'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '14A1-'
    except: 
        message2print = "{(Step 14Z1/70) yielded" + "; userdata-rpu2execute4xi-yielded-by-execute2task4rpu: " + str(rpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '14Z1-'
                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    rpu2execute4xi ['ACK2RETURN']  = code2ack
    rpu2execute4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; rpu2execute4xi-returning-by-execute2task4rpu: " + str(rpu2execute4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    
    return rpu2execute4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernel4rpu" usage = "
#     
#   print('(Step 2A1/700) OF RPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR RPU ', time4xi())       
#   try:
#       response4create2kernel = create2kernel4rpu()
#   except:
#       print('(Step 2Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR RPU *** ', time4xi())
#          
#">

# -------------------------------------------------------------------------------------------------   
def create2kernel4rpu(task4kernel2rpu=None):

    '''
    creates kernel for RPU
    '''
    global rpu2kernel4xi                                                                                            # Kernel of RPU    
    global folder2lib4rpu  
    global kb2kernel4rpu                                                                                            # Knowledgebase for kernel      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernel4rpu" 
    method2print = "create2kernel4rpu"

    message2print = "{(Step 1A/70) started" + "; create2kernel4rpu-started: " + str(create2kernel4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2kernel4rpu at 0x0000000003AAD8C8> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2rpu-to-create2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    #1: None
    #2: 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    rpu2kernel4xi = {}                                                                                              # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernel2rpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO RPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4kernel2rpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4kernel2rpu-created-by-create2kernel4rpu: " + str(task4kernel2rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - EXTRA                 
            # ---------------------------------------------------------------------------------------------
                        
            function2callback4rpu = trace2kernel4rpu                                                                # CALLBACK FUNCTION FOR RPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4rpu-created-by-create2kernel4rpu: " + str(function2callback4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4rpu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4rpu"                                                          # MODULE OF RPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4rpu"                                                          # FUNCTION OF RPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4rpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR RPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4rpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4rpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4rpu',
            #  'METHOD': 'create2kernel4rpu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2rpu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO RPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2rpu['FUNCTION2CALLBACK'] = function2callback4rpu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2rpu-created-by-create2kernel4rpu: " + str(task4kernel2rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4rpu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4rpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4rpu',
            #  'METHOD': 'create2kernel4rpu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}


            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-created-by-create2kernel4rpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            try:
                platform2xi = get2platformids4xi()                                                                  # PLATFORM IS COMMON TO ALL DEVICES I.E TO DEVICE XI
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2kernel4rpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 03:33:11 12/06/11 Pacific Standard Time}
                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2kernel4rpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4kernel2rpu['PLATFORM'] = platform2xi                                                               # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - EXTRA                   
            # ---------------------------------------------------------------------------------------------    
            context2rpu = {}
            message2print = "{(Step 3A/70) trying" + "; context2rpu-trying-by-create2kernel4rpu: " + str(context2rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2rpu = get2context4rpu()                                                                     # NO PARAMETERS - THE SYSTEM CREATES CONTEXT IF REQUIRED  
                
                message2print = "{(Step 3B/70) got" + "; context2rpu-got-by-create2kernel4rpu: " + str(context2rpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2rpu-failed-by-create2kernel4rpu: " + str(context2rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
                
            task4kernel2rpu ['CONTEXT'] = context2rpu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------    
            device2rpu = {}
            
            message2print = "{(Step 4A/70) trying" + "; device2rpu-trying-by-create2kernel4rpu: " + str(device2rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2rpu = get2rpu4xi()                                                                           # THE SYSTEM CREATES DEVICE INFO, IF NECESSARY    
                
                message2print = "{(Step 4B/70) got" + "; device2rpu-got-by-create2kernel4rpu: " + str(device2rpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2rpu-failed-by-create2kernel4rpu: " + str(device2rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4kernel2rpu ['DEVICE'] = device2rpu
            
                   
            # ---------------------------------------------------------------------------------------------
            # (5) ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4kernel2rpu ['CODE2ERROR'] = 0             
            code2ack  = code2ack + '5B-'              

            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            queue2rpu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2rpu-trying-by-create2kernel4rpu: " + str(queue2rpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2rpu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2rpu-got-by-create2kernel4rpu: " + str(queue2rpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2rpu-failed-by-create2kernel4rpu: " + str(queue2rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2rpu ['QUEUE'] = queue2rpu

            
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - EXTRA                              
            # ---------------------------------------------------------------------------------------------         
            pipe2rpu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2rpu-trying-by-create2kernel4rpu: " + str(pipe2rpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2rpu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2rpu-got-by-create2kernel4rpu: " + str(pipe2rpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2rpu-failed-by-create2kernel4rpu: " + str(pipe2rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2rpu ['PIPE'] = pipe2rpu 
            
            # ---------------------------------------------------------------------------------------------
            # (8) COMMAND QUEUE INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            commandqueueinfo2rpu = {}
           
            message2print = "{(Step 8A/70) trying" + "; commandqueueinfo2rpu-trying-by-create2kernel4rpu: " + str(commandqueueinfo2rpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                        
            try:
                commandqueueinfo2rpu = get2commandqueueinfo4rpu()                                                   # SYSTEM CREATES COMMAND QUEUE, IF NECESSARY   
                message2print = "{(Step 8B/70) got" + "; commandqueueinfo2rpu-got-by-create2kernel4rpu: " + str(commandqueueinfo2rpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '8B-'  
            except:
                message2print = "{(Step 8Z/70) failed" + "; commandqueueinfo2rpu-failed-by-create2kernel4rpu: " + str(commandqueueinfo2rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '8Z-'
        
            task4kernel2rpu ['COMMANDQUEUE'] = commandqueueinfo2rpu
            
            
            
            # ---------------------------------------------------------------------------------------------
            # (9) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            bufferinfo2rpu = {}
           
            message2print = "{(Step 9A/70) trying" + "; bufferinfo2rpu-trying-by-create2kernel4rpu: " + str(bufferinfo2rpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                bufferinfo2rpu = get2bufferinfo4rpu()                                                               # SYSTEM CREATES BUFFER FOR RPU, IF NECESSARY
                message2print = "{(Step 9B/70) got" + "; bufferinfo2rpu-got-by-create2kernel4rpu: " + str(bufferinfo2rpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '9B-' 
            except:
                message2print = "{(Step 9Z/70) failed" + "; bufferinfo2rpu-failed-by-create2kernel4rpu: " + str(bufferinfo2rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '9Z-'
        
            task4kernel2rpu ['BUFFER'] = bufferinfo2rpu 
            
            # ---------------------------------------------------------------------------------------------
            # (10) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            eventinfo2rpu = {}
           
            message2print = "{(Step 10A/70) trying" + "; eventinfo2rpu-trying-by-create2kernel4rpu: " + str(eventinfo2rpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                eventinfo2rpu = get2eventinfo4rpu()                                                                 # SYSTEM CREATES EVENT IF NECESSAY   
                message2print = "{(Step 10B/70) got" + "; eventinfo2rpu-got-by-create2kernel4rpu: " + str(eventinfo2rpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'DATA2CALLBACK': ... 
                
                code2ack  = code2ack + '10B-' 
            except:
                message2print = "{(Step 10Z/70) failed" + "; eventinfo2rpu-failed-by-create2kernel4rpu: " + str(eventinfo2rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '10Z-'
        
            task4kernel2rpu ['EVENT'] = eventinfo2rpu             

            
            task4kernel2rpu ['CODE4PY']       = {}                                                                  
            task4kernel2rpu ['CODE4CPP']      = {}                                                                  
            task4kernel2rpu ['CODE4C']        = {} 
            task4kernel2rpu ['CODE4CL']       = {} 
                       
            task4kernel2rpu ['CODE4PYC']      = {}                                                                  
            task4kernel2rpu ['CODE4BIN']      = {}
 
            task4kernel2rpu ['DIRECTORY4PY']  = {}                                                                  
            task4kernel2rpu ['DIRECTORY4CPP'] = {}
            task4kernel2rpu ['DIRECTORY4C']   = {}
            task4kernel2rpu ['DIRECTORY4CL']  = {}
                                                                                                       
            task4kernel2rpu ['DIRECTORY4PYC'] = {}                                                                  
            task4kernel2rpu ['DIRECTORY4BIN'] = {}                                                                  
                                               
            # ---------------------------------------------------------------------------------------------
            # (12A0) DIRECTORY4PY - PYTHON                 
            # ---------------------------------------------------------------------------------------------             
            dir2py4rpu = folder2lib4rpu                                                                                                                                                            
            message2print = "{(Step 12A0/70) set" + "; dir2py4rpu-set-by-create2kernel4rpu to: " + str(dir2py4rpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4rpu 
            code2ack  = code2ack + '12A0-' 
        
            task4kernel2rpu ['DIRECTORY4PY'] = dir2py4rpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A0) CODE4PY - PYTHON         
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A0/70) using" + "; DirectoryWalker-using-by-create2kernel4rpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2py4rpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B0/70) examining" + "; directory-examining-by-create2kernel4rpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C0/70) examining" + "; file-examining-by-create2kernel4rpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4rpu + rpu2sampler4xi5test.py; rpu2dummy4xi5test.cpp 
                    
                    message2print = "{(Step 14D0/70) calling" + "; fetch2kernel4rpu-calling-by-create2kernel4rpu: " + str(fetch2kernel4rpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4rpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E0/70) passing" + "; file2walk-passing-to-fetch2kernel4rpu-by-create2kernel4rpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4rpu + rpu2sampler4xi5test.py; rpu2dummy4xi5test.cpp 
                    
                    fetch2kernel4rpu(file2walk)                                                                     # FETCHES KERNEL FILES INTO FETCH2CODE4RPU DICTIONARY 
                    
                    message2print = "{(Step 14E0/70) performed" + "; fetch2kernel4rpu-performed-by-create2kernel4rpu: " + str(fetch2kernel4rpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4rpu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14F0/70) got" + "; fetch2code4rpu-got-by-create2kernel4rpu: " + str(fetch2code4rpu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # ...  {1: '...profile = "11" />\n', 2: '# --
            
            
                     
            keys2explore4rpu = fetch2code4rpu.keys()
            message2print = "{(Step 14G0/70) using" + "; keys2explore4rpu-using-by-create2kernel4rpu: " + str(keys2explore4rpu) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)             
            # folder2lib4rpu + rpu2sampler4xi5test.py; rpu2dummy4xi5test.cpp
            
            for key2explore4rpu in keys2explore4rpu:
                name2program4rpu=os.path.splitext(key2explore4rpu)                                                  # rpu2sampler4xi5test + py
                key2extension4rpu = name2program4rpu[1]                                                              
                if key2extension4rpu == '.py':                          
                    task4kernel2rpu ['CODE4PY'] [key2explore4rpu] = fetch2code4rpu[key2explore4rpu]                 # Python code(s)      

            # ---------------------------------------------------------------------------------------------
            # (14H0) SIZE4PY - PYTHON SOURCE            
            # ---------------------------------------------------------------------------------------------                                                
            size2py4rpu  = {}
            keys2py4rpu = fetch2code4rpu.keys()                                                                     # rpu2sampler4xi5test.py
            for key2py4rpu in keys2py4rpu:
                name2program4rpu=os.path.splitext(key2py4rpu)                                                       # rpu2sampler4xi5test + py
                key2extension4rpu = name2program4rpu[1]                                                             # py   
                if key2extension4rpu == '.py':                          
                    size2py4rpu[key2py4rpu] = len(fetch2code4rpu[key2py4rpu])                                       # length of saved py code 

            task4kernel2rpu ['SIZE4PY'] = size2py4rpu
                               
            message2print = "{(Step 14H0/70) set" + "; size2py4rpu-set-by-create2kernel4rpu to: " + str(size2py4rpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {folder2lib4rpu + rpu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '14H1-' 
            

            # ---------------------------------------------------------------------------------------------
            # (12A1) C, C++, CL SOURCE                   
            # ---------------------------------------------------------------------------------------------             
            dir2c4rpu = folder2lib4rpu                                                                                                                                                            
            message2print = "{(Step 12A1/70) set" + "; dir2c4rpu-set-by-create2kernel4rpu to: " + str(dir2c4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # folder2lib4rpu 
            code2ack  = code2ack + '12A1-' 
        
            task4kernel2rpu ['DIRECTORY4CPP']  = dir2c4rpu
            task4kernel2rpu ['DIRECTORY4C']    = dir2c4rpu
            task4kernel2rpu ['DIRECTORY4CLPP'] = dir2c4rpu
            task4kernel2rpu ['CODE4CPP'] = {} 
            task4kernel2rpu ['CODE4C']   = {} 
            task4kernel2rpu ['CODE4CL']  = {}            
            
            # ---------------------------------------------------------------------------------------------
            # (14A1) C, C++, CL SOURCE   
            # ---------------------------------------------------------------------------------------------             
            keys2c4rpu = fetch2code4rpu.keys()
            for key2c4rpu in keys2c4rpu:
                name2c4rpu=os.path.splitext(key2c4rpu)                                                  
                key2extension4rpu = name2c4rpu[1]                                                             # C++, C, CL 
                if key2extension4rpu == '.cpp':                          
                    task4kernel2rpu ['CODE4CPP'] [key2c4rpu] = fetch2code4rpu[key2c4rpu]                     
                    message2print = "{(Step 14G1/70) set" + "; key2c4rpu-set-by-create2kernel4rpu to: " + str(key2c4rpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4rpu + rpu2dummy4xi5test.cpp
                if key2extension4rpu == '.c':                          
                    task4kernel2rpu ['CODE4C'] [key2c4rpu] = fetch2code4rpu[key2c4rpu]                     
                    message2print = "{(Step 14G2/70) set" + "; key2c4rpu-set-by-create2kernel4rpu to: " + str(key2c4rpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4rpu +
                if key2extension4rpu == '.cl':                          
                    task4kernel2rpu ['CODE4CL'] [key2c4rpu] = fetch2code4rpu[key2c4rpu]                     
                    message2print = "{(Step 14G3/70) set" + "; key2c4rpu-set-by-create2kernel4rpu to: " + str(key2c4rpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4rpu + 
                                                                
            # ----------------------------------------------------------------------------------------------
            # (14H1) SIZE4C - C C++ CL SOURCE HAS THE SAME FOLDER AS FOR PYTHON SOURCE - ALREADY FETCHED           
            # ----------------------------------------------------------------------------------------------                                                
            size2c4rpu  = {}
            keys2c4rpu = fetch2code4rpu.keys()                                                                # 
            for key2c4rpu in keys2c4rpu:
                name2program4rpu=os.path.splitext(key2c4rpu)                                                  # 
                key2extension4rpu = name2program4rpu[1]                                                       #    
                if key2extension4rpu == '.cpp':                          
                    size2c4rpu[key2c4rpu] = len(fetch2code4rpu[key2c4rpu])                                    # length of saved C++ code
                    task4kernel2rpu ['SIZE4CPP'] = size2c4rpu 
                if key2extension4rpu == '.c':                          
                    size2c4rpu[key2c4rpu] = len(fetch2code4rpu[key2c4rpu])                                    # length of saved C code
                    task4kernel2rpu ['SIZE4C'] = size2c4rpu
                if key2extension4rpu == '.cl':                          
                    size2c4rpu[key2c4rpu] = len(fetch2code4rpu[key2c4rpu])                                    # length of saved CL code
                    task4kernel2rpu ['SIZE4CL'] = size2c4rpu 
                                       
            
                               
            message2print = "{(Step 14H1/70) set" + "; size2c4rpu-set-by-create2kernel4rpu to: " + str(size2c4rpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # folder2lib4rpu + rpu2dummy4xi5test.cpp': 331}
            code2ack  = code2ack + '14H1-' 
            
                                                  
            # ---------------------------------------------------------------------------------------------
            # (12B2) DIRECTORY FOR PYTHON CACHE - REQUIRED                      
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4rpu = folder2lib4rpu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 12B2/70) set" + "; dir2pycache4rpu-set-by-create2kernel4rpu to: " + str(dir2pycache4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4rpu + '__pycache__//'
            code2ack  = code2ack + '12B2-' 
        
            task4kernel2rpu ['DIRECTORY4PYC'] = dir2pycache4rpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A2) CODE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A2/70) using" + "; DirectoryWalker-using-by-create2kernel4rpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2pycache4rpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B2/70) examining" + "; directory-examining-by-create2kernel4rpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C2/70) examining" + "; file-examining-by-create2kernel4rpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4rpu + __pycache__//rpu2sampler4xi5test.cpython-33.pyc
                    
                    message2print = "{(Step 14D2/70) calling" + "; fetch2kernel4rpu-calling-by-create2kernel4rpu: " + str(fetch2kernel4rpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4rpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E2/70) passing" + "; file2walk-passing-to-fetch2kernel4rpu-by-create2kernel4rpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4rpu + __pycache__//rpu2sampler4xi5test.cpython-33.pyc
                    
                    fetch2kernel4rpu(file2walk)                                                                     # fetches kernel files into fetch2code4rpu dictionary 
                    
                    message2print = "{(Step 14F2/70) performed" + "; fetch2kernel4rpu-performed-by-create2kernel4rpu: " + str(fetch2kernel4rpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4rpu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14G2/70) got" + "; fetch2code4rpu-got-by-create2kernel4rpu: " + str(fetch2code4rpu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # 
            
            task4kernel2rpu ['CODE4PYC'] = {}
            keys2pyc4rpu = fetch2code4rpu.keys()
            for key2pyc4rpu in keys2pyc4rpu:
                name2program4rpu=os.path.splitext(key2pyc4rpu)                                                      # rpu2sampler4xi5test.cpython-33.pyc
                key2extension4rpu = name2program4rpu[1]                                                             # pyc 
   
                if key2extension4rpu == '.pyc':                          
                    task4kernel2rpu ['CODE4PYC'] [key2pyc4rpu] = fetch2code4rpu[key2pyc4rpu]                        # binary code(s)
                    message2print = "{(Step 14H2/70) set" + "; key2pyc4rpu-set-by-create2kernel4rpu to: " + str(key2pyc4rpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    #    
                                     
            size2pyc4rpu  = {}

            for key2pyc4rpu in keys2pyc4rpu:
                name2program4rpu=os.path.splitext(key2pyc4rpu)                                                      # rpu2sampler4xi5test.cpython-32 + pyc
                key2extension4rpu = name2program4rpu[1]                                                             # pyc 
                if key2extension4rpu == '.pyc':                          
                    size2pyc4rpu[key2pyc4rpu] = len(fetch2code4rpu[key2pyc4rpu])                                    # length of saved binary code
                    message2print = "{(Step 14I2/70) set" + "; key2pyc4rpu-set-by-create2kernel4rpu to: " + str(key2pyc4rpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # 
                                              
            # ---------------------------------------------------------------------------------------------
            # (14I2) SIZE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2rpu ['SIZE4PYC'] = size2pyc4rpu
                               
            message2print = "{(Step 14J2/70) set" + "; size2pyc4rpu-set-by-create2kernel4rpu to: " + str(size2pyc4rpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 
            code2ack  = code2ack + '14J2-' 

                                               
            # ---------------------------------------------------------------------------------------------
            # (12A3) DIRECTORY FOR C++, C, CL BIN - REQUIRED                    
            # ---------------------------------------------------------------------------------------------             
            dir2bin4rpu = folder2lib4rpu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4rpu-set-by-create2kernel4rpu to: " + str(dir2bin4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4rpu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2rpu ['DIRECTORY4BIN'] = dir2bin4rpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A3) CODE4BIN FOR C++, C, CL - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A3/70) using" + "; DirectoryWalker-using-by-create2kernel4rpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2bin4rpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B3/70) examining" + "; directory-examining-by-create2kernel4rpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C3/70) examining" + "; file-examining-by-create2kernel4rpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4rpu + bin//rpu2dummy4xi5test.exe
                    
                    message2print = "{(Step 14D3/70) calling" + "; fetch2kernel4rpu-calling-by-create2kernel4rpu: " + str(fetch2kernel4rpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4rpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E3/70) passing" + "; file2walk-passing-to-fetch2kernel4rpu-by-create2kernel4rpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4rpu + bin//rpu2dummy4xi5test.exe
                    
                    fetch2kernel4rpu(file2walk)                                                                     # fetches kernel files into fetch2code4rpu dictionary 
                    
                    message2print = "{(Step 14E3/70) performed" + "; fetch2kernel4rpu-performed-by-create2kernel4rpu: " + str(fetch2kernel4rpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4rpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14F3/70) got" + "; fetch2code4rpu-got-by-create2kernel4rpu: " + str(fetch2code4rpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # 

            task4kernel2rpu ['CODE4BIN'] = {}
            
            keys2bin4rpu = fetch2code4rpu.keys()
            message2print = "{(Step 14G3/70) using" + "; keys2bin4rpu-using-by-create2kernel4rpu: " + str(keys2bin4rpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4rpu + 'rpu2dummy4xi5test.cpp', 'rpu2sampler4xi5test.py']
            
            for key2bin4rpu in keys2bin4rpu:
                name2program4rpu=os.path.splitext(key2bin4rpu)                                                      # rpu2dummy4xi5test.exe
                key2extension4rpu = name2program4rpu[1]                                                             # bin 
   
                if key2extension4rpu == '.exe':                          
                    task4kernel2rpu ['CODE4BIN'] [key2bin4rpu] = fetch2code4rpu[key2bin4rpu]                        # binary code(s)   
                                        
            size2bin4rpu  = {}
            keys2bin4rpu = fetch2code4rpu.keys()                                                                    # rpu2dummy4xi5test.exe
            for key2bin4rpu in keys2bin4rpu:
                name2program4rpu=os.path.splitext(key2bin4rpu)                                                      # rpu2sampler4xi5test.cpython-32 + bin
                key2extension4rpu = name2program4rpu[1]                                                             # bin 
                if key2extension4rpu == '.exe':                          
                    size2bin4rpu[key2bin4rpu] = len(fetch2code4rpu[key2bin4rpu])                                    # length of saved binary code
                        
            # ---------------------------------------------------------------------------------------------
            # (14H3) SIZE4BIN - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2rpu ['SIZE4BIN'] = size2bin4rpu
                               
            message2print = "{(Step 14H3/70) set" + "; size2bin4rpu-set-by-create2kernel4rpu to: " + str(size2bin4rpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {}
            code2ack  = code2ack + '14H3-' 

            # ---------------------------------------------------------------------------------------------
            # (14J) COUNT4PY, COUNT4C,COUNT4PYC,COUNT4BIN                
            # ---------------------------------------------------------------------------------------------             
            task4kernel2rpu ['COUNT4PY']     = 0
            task4kernel2rpu ['COUNT4CPP']    = 0
            task4kernel2rpu ['COUNT4C']      = 0
            task4kernel2rpu ['COUNT4CL']     = 0
            task4kernel2rpu ['COUNT4PYC']    = 0
            task4kernel2rpu ['COUNT4BIN']    = 0

            keys2code4rpu = fetch2code4rpu.keys()
            message2print = "{(Step 14J/70) using" + "; keys2code4rpu-using-by-create2kernel4rpu: " + str(keys2code4rpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4rpu + 'rpu2dummy4xi5test.cpp', folder2lib4rpu + 'rpu2sampler4xi5test.py']

            
            for key2code4rpu in keys2code4rpu:
                name2program4rpu=os.path.splitext(key2code4rpu)                                                    
                key2extension4rpu = name2program4rpu[1]                                                             
                if key2extension4rpu == '.py':                          
                    task4kernel2rpu ['COUNT4PY']     = task4kernel2rpu ['COUNT4PY']  + 1 
                if key2extension4rpu == '.cpp':                          
                    task4kernel2rpu ['COUNT4CPP']    = task4kernel2rpu ['COUNT4CPP'] + 1                                            
                if key2extension4rpu == '.c':                          
                    task4kernel2rpu ['COUNT4C']      = task4kernel2rpu ['COUNT4C']   + 1              
                if key2extension4rpu == '.cl':                          
                    task4kernel2rpu ['COUNT4CL']     = task4kernel2rpu ['COUNT4CL']  + 1                                  
                if key2extension4rpu == '.pyc':                          
                    task4kernel2rpu ['COUNT4PYC']    = task4kernel2rpu ['COUNT4PYC'] + 1                            
                if key2extension4rpu == '.exe':                          
                    task4kernel2rpu ['COUNT4BIN']    = task4kernel2rpu ['COUNT4BIN'] + 1                                                                                 
            
            message2print = "{(Step 14K/70) set" + "; count4py-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['COUNT4PY'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            
            message2print = "{(Step 14L/70) set" + "; count4cpp-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['COUNT4CPP'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            message2print = "{(Step 14M/70) set" + "; count4c-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['COUNT4C'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0 
            message2print = "{(Step 14N/70) set" + "; count4cl-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['COUNT4CL'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                         
            
            message2print = "{(Step 14M/70) set" + "; count4pyc-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['COUNT4PYC'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0
            
            message2print = "{(Step 14N/70) set" + "; count4bin-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['COUNT4BIN'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                                                
            code2ack  = code2ack + '14N-'
            
            # ---------------------------------------------------------------------------------------------
            # (15) LANGUAGE - EXTRA                             
            # ---------------------------------------------------------------------------------------------             
            task4kernel2rpu ['LANGUAGE'] = {}
            
            for key2code4rpu in keys2code4rpu:
                name2program4rpu=os.path.splitext(key2code4rpu)                                                     
                key2extension4rpu = name2program4rpu[1]                                                             
                if key2extension4rpu == '.py':                          
                    task4kernel2rpu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4rpu == '.cpp':                          
                    task4kernel2rpu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4rpu == '.c':                          
                    task4kernel2rpu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4rpu == '.cl':                          
                    task4kernel2rpu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4rpu-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '15B-' 
                      
            # ---------------------------------------------------------------------------------------------
            # (16) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            count2reference2rpu  = 1
           
            message2print = "{(Step 16B/70) set" + "; count2reference2rpu-set-by-create2kernel4rpu to: " + str(count2reference2rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '16B-' 
        
            task4kernel2rpu ['COUNT2REFERENCE'] = count2reference2rpu                                 
                                    
            # ---------------------------------------------------------------------------------------------
            # (17) PROGRAM - REQUIRED                           
            # ---------------------------------------------------------------------------------------------             
            task4kernel2rpu ['PROGRAM'] = None
            message2print = "{(Step 17A/70) try" + "; program2rpu-try-by-create2kernel4rpu: " + str(task4kernel2rpu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2rpu ['PROGRAM'] = create2programwithsource4rpu()
                keys2program = task4kernel2rpu ['PROGRAM'].keys()
                
                message2print = "{(Step 17B/70) set" + "; program-set-by-create2kernel4rpu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'COUNT2REFERENCE', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '17B-'
            except:
                message2print = "{(Step 17Z1/70) failed" + "; task4kernel2rpu-failed-by-create2kernel4rpu: " + str(task4kernel2rpu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '17Z-'
                                    
            # ---------------------------------------------------------------------------------------------
            # (18) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2rpu ['FUNCTION'] = {}
            message2print = "{(Step 18A0/70) set" + "; function4rpu-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2rpu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 18A1/70) set" + "; pythonfunction4rpu-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4rpu  = kb2kernel4rpu ['.py'] ['TAG']
            message2print = "{(Step 18A2/70) using" + "; tag2search4rpu-using-by-create2kernel4rpu: " + str(tag2search4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4rpu    = kb2kernel4rpu ['.py'] ['VALUE']
            message2print = "{(Step 18A3/70) using" + "; value2search4rpu-using-by-create2kernel4rpu: " + str(value2search4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # rpu2sampler4xi5test
            
            attribute2search4rpu= kb2kernel4rpu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 18A4/70) using" + "; attribute2search4rpu-using-by-create2kernel4rpu: " + str(attribute2search4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4rpu in keys2code4rpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4rpu]
                    keys2line4rpu = code2examine4rpu.keys()
                    for key2line4rpu in keys2line4rpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4rpu] [key2line4rpu]
                        # message2print = "{(Step 18A5/70) examining" + "; line2examine4rpu-examining-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4rpu,tag2search4rpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 18B/70) examining" + "; line2function4rpu-examining-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # <... rpu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4rpu,value2search4rpu)
                            if index2function == -1:
                                message2print = "{(Step 18C/70) skipped" + "; line2function4rpu-skipped-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # <... set2trace4sampler" ... # ...function = "rpu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4rpu,attribute2search4rpu)             # ...function = "rpu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 18D/70) warning" + "; line2function4rpu-warning-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 18E/70) accepted" + "; line2examine4rpu-accepted-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ...function = "rpu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4rpu = line2examine4rpu[index2function:index2usage-2]
                                    
                                    task4kernel2rpu ['FUNCTION'] ['.py'] [key2pythonfunction4rpu] = {}                                  

                                    message2print = "{(Step 18F/70) used" + "; key2pythonfunction4rpu-used-by-create2kernel4rpu: " + str(key2pythonfunction4rpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # rpu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '18F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 18Z1/70) failed" + "; task4kernel2rpu-failed-by-create2kernel4rpu: " + str(task4kernel2rpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '18Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (19) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2rpu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 19A0F/70) set" + "; cplusfunction4rpu-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4rpu      = kb2kernel4rpu ['.cpp'] ['TAG']
            message2print = "{(Step 19A2/70) using" + "; tag2search4rpu-using-by-create2kernel4rpu: " + str(tag2search4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <...            
            attribute2search4rpu= kb2kernel4rpu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 19A4/70) using" + "; attribute2search4rpu-using-by-create2kernel4rpu: " + str(attribute2search4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4rpu in keys2code4rpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4rpu]
                    message2print = "{(Step 19A5/70) using" + "; key2code4rpu-using-by-create2kernel4rpu: " + str(key2code4rpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # rpu2dummy4xi5test.cpp
                       
                    keys2line4rpu = code2examine4rpu.keys()
                    # message2print = "{(Step 19A6/70) using" + "; keys2line4rpu-using-by-create2kernel4rpu: " + str(keys2line4rpu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4rpu in keys2line4rpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4rpu] [key2line4rpu]
                        # message2print = "{(Step 19A7/70) examining" + "; line2examine4rpu-examining-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # /*<... nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4rpu,tag2search4rpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 19B1/70) examining" + "; line2function4rpu-examining-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # ... function = "OCLError" usage = "error code checking"*/
                            # ... function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 19B2/70) using" + "; attribute2search4rpu-using-by-create2kernel4rpu: " + str(attribute2search4rpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4rpu,attribute2search4rpu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 19C/70) skipped" + "; line2function4rpu-skipped-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 19E/70) accepted" + "; line2examine4rpu-accepted-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "nbody_kern" usage = "kernel example 1"*/; 
                                # ... function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4rpu = line2examine4rpu[27:index2usage-2]  
                                task4kernel2rpu ['FUNCTION'] ['.cpp'] [key2kernelfunction4rpu] =  {}                                       

                                message2print = "{(Step 19F/70) used" + "; key2kernelfunction4rpu-used-by-create2kernel4rpu: " + str(key2kernelfunction4rpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '19F-'
                                    
                                    
            except:
                message2print = "{(Step 19Z1/70) failed" + "; task4kernel2rpu-failed-by-create2kernel4rpu: " + str(task4kernel2rpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #   
                #             
                code2nack  = code2nack + '19Z-'           
                                                      
            # ---------------------------------------------------------------------------------------------
            # EOF CREATING TASK4KERNEL2RPU                  
            # ---------------------------------------------------------------------------------------------                                                                                                                                                          
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernel2rpu-yielded-by-create2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-' 

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4kernel2rpu.keys()        
    message2print = "{(Step 19A/70) using" + "; keys2task-using-by-create2kernel4rpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    #1 this program created:
    # ['BUFFER'  ... 'LANGUAGE', 'PIPE', 
    #  'PLATFORM', 'PROGRAM', 'QUEUE' ....']
    #2 caller passed:
    # ['FUNCTION', 'PROGRAM']
    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - CREATE PROGRAM OBJECT FOR RPU - BUILD REQUIRED ONES IF USER HAS FORGOTTEN ! 
    # ---------------------------------------------------------------------------------------------    
    rpu2kernel4xi = {}                                                                                             # CREATE INITIALIZES DICTIONARY!                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; rpu2kernel4xi-initialized-by-create2kernel4rpu to: " + str(rpu2kernel4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    if (('DATA2CALLBACK' not in keys2task) or ('FUNCTION2CALLBACK' not in keys2task)):
        try:            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - REQUIRED                
            # ---------------------------------------------------------------------------------------------
                     
            function2callback4rpu = trace2kernel4rpu                                                                # CALLBACK FUNCTION FOR RPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4rpu-created-by-create2kernel4rpu: " + str(function2callback4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4rpu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4rpu"                                                          # MODULE OF RPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4rpu"                                                          # FUNCTION OF RPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4rpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR RPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4rpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4rpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4rpu',
            #  'METHOD': 'create2kernel4rpu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2rpu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO RPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2rpu['FUNCTION2CALLBACK'] = function2callback4rpu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2rpu-created-by-create2kernel4rpu: " + str(task4kernel2rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4rpu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4rpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4rpu',
            #  'METHOD': 'create2kernel4rpu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}
        except: 
            message2print = "{(Step 1Z2/70) yielded" + "; callbacks-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'     
                
    if 'DATA2CALLBACK' in keys2task:
        message2print = "{(Step 21A0/70) try" + "; data2callback-try-by-create2kernel4rpu: {}" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21A/70) - DATA2CALLBACK - REQUIRED 
            # -----------------------------------------------------------------------------------------               
            rpu2kernel4xi['DATA2CALLBACK'] = task4kernel2rpu['DATA2CALLBACK']
            
            message2print = "{(Step 21A1/70) initialized" + "; data2callback-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4rpu-failed ; time: 04:42:53 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4rpu',
            #  'METHOD': 'create2kernel4rpu'}
    
            code2ack  = code2ack + '21A1-'
        except: 
            message2print = "{(Step 21Z1/70) yielded" + "; data2callback-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '21Z1-'
    
    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22B/70) - FUNCTION2CALLBACK - REQUIRED
            # -----------------------------------------------------------------------------------------               
            rpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernel2rpu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 22B1/70) initialized" + "; function2callback-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2kernel4rpu at 0x000000000422F6C8>
            
            code2ack  = code2ack + '22B1-'
        except: 
            message2print = "{(Step 22Z2/70) yielded" + "; function2callback-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z2-' 
        
        message2print = "{(Step 22C0/70) try" + "; platform-try-by-create2kernel4rpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #

        
    if 'PLATFORM' in keys2task:         
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22C/70) - PLATFORM - EXTRA
            # -----------------------------------------------------------------------------------------               
            rpu2kernel4xi['PLATFORM'] = task4kernel2rpu['PLATFORM']
            
            message2print = "{(Step 22C1/70) initialized" + "; platform-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    
    
            code2ack  = code2ack + '22C1-'
        except: 
            message2print = "{(Step 22Z3/70) yielded" + "; platform-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z3-' 
            
    
    if 'CONTEXT' in keys2task:        
        message2print = "{(Step 23A/70) try" + "; context2rpu-try-by-create2kernel4rpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 23/70) - CONTEXT  - EXTRA
            # -----------------------------------------------------------------------------------------               
            rpu2kernel4xi['CONTEXT'] = task4kernel2rpu['CONTEXT']
            
            message2print = "{(Step 23B/70) initialized" + "; context-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...      
            
            code2ack  = code2ack + '23B-'
        except: 
            message2print = "{(Step 23Z1/70) yielded" + "; context-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        
            code2nack  = code2nack + '23Z1-' 
    
    if 'DEVICE' in keys2task:        
        message2print = "{(Step 24A/70) try" + "; device-try-by-create2kernel4rpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 24/70) - DEVICE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            rpu2kernel4xi['DEVICE'] = task4kernel2rpu['DEVICE']
            
            message2print = "{(Step 24B/70) initialized" + "; device-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
            
            code2ack  = code2ack + '24B-'
        except: 
            message2print = "{(Step 24Z1/70) yielded" + "; device-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '24Z1-'
    
    if 'CODE2ERROR' in keys2task:                     
        message2print = "{(Step 25A/70) try" + "; code2error-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 25/70) - ERROR CODE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            rpu2kernel4xi['CODE2ERROR'] = task4kernel2rpu['CODE2ERROR']
            
            message2print = "{(Step 25B/70) initialized" + "; code2error-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '25B-'
        except: 
            message2print = "{(Step 25Z1/70) yielded" + "; code2error-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '25Z1-'
                            
    if 'QUEUE' not in keys2task: 
        try:
            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - REQUIRED                          
            # ---------------------------------------------------------------------------------------------         
            queue2rpu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2rpu-trying-by-create2kernel4rpu: " + str(queue2rpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2rpu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2rpu-got-by-create2kernel4rpu: " + str(queue2rpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2rpu-failed-by-create2kernel4rpu: " + str(queue2rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2rpu ['QUEUE'] = queue2rpu
        except:
            message2print = "{(Step 26Z1/70) yielded" + "; queue-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z1-'             

    if 'QUEUE' in keys2task:          
        message2print = "{(Step 26A/70) try" + "; queue-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 26/70) - QUEUE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            rpu2kernel4xi['QUEUE'] = task4kernel2rpu['QUEUE']
            
            message2print = "{(Step 26B/70) initialized" + "; queue-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <queue4xi.Queue4Xi object at 0x0000000003E72828> 
            
            code2ack  = code2ack + '26B-'
        except: 
            message2print = "{(Step 26Z2/70) yielded" + "; queue-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z2-' 
              
    if 'PIPE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------         
            pipe2rpu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2rpu-trying-by-create2kernel4rpu: " + str(pipe2rpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2rpu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2rpu-got-by-create2kernel4rpu: " + str(pipe2rpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2rpu-failed-by-create2kernel4rpu: " + str(pipe2rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2rpu ['PIPE'] = pipe2rpu 
        except: 
            message2print = "{(Step 27Z1/70) yielded" + "; pipe-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z1-'
                                 
    if 'PIPE' in keys2task:                                
        message2print = "{(Step 27A/70) try" + "; pipe-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 27/70) - PIPE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            rpu2kernel4xi['PIPE'] = task4kernel2rpu['PIPE']
            
            message2print = "{(Step 27B/70) initialized" + "; pipe-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
            
            code2ack  = code2ack + '27B-'
        except: 
            message2print = "{(Step 27Z2/70) yielded" + "; pipe-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z2-' 

    if 'COMMANDQUEUE' in keys2task:
        message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-create2kernel4rpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (28) COMMAND QUEUE - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            rpu2kernel4xi['COMMANDQUEUE']  = task4kernel2rpu['COMMANDQUEUE']  
     
            message2print = "{(Step 28B/70) initialized" + "; commandqueue-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                    
            code2ack  = code2ack + '28B-'
        except: 
            message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
                  
            code2nack  = code2nack + '28Z1-'    
    
    if 'BUFFER' in keys2task:
        message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-create2kernel4rpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (29) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            rpu2kernel4xi['BUFFER']  = task4kernel2rpu['BUFFER']  
     
            message2print = "{(Step 29B/70) initialized" + "; bufferinfo-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
            
            
            code2ack  = code2ack + '29B-'
        except: 
            message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '29Z1-'            
    
    if 'EVENT' in keys2task:
        message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-create2kernel4rpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (30) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            rpu2kernel4xi['EVENT']  = task4kernel2rpu['EVENT']  
     
            message2print = "{(Step 30B/70) initialized" + "; eventinfo-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'DATA2CALLBACK' ... 
            
            code2ack  = code2ack + '30B-'
        except: 
            message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '30Z1-'
                        
    
    if 'COUNT4PY' in keys2task:               
        message2print = "{(Step 31A1/70) try" + "; count2py4rpu-try-by-create2kernel4rpu: " + str(task4kernel2rpu['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PY - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['COUNT4PY']  = task4kernel2rpu['COUNT4PY']  
    
            message2print = "{(Step 31A2/70) initialized" + "; count2py4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31A2-'
        except: 
            message2print = "{(Step 31Z1/70) yielded" + "; count2py4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z1-'     
    
    if 'COUNT4CPP' in keys2task:               
        message2print = "{(Step 31B1/70) try" + "; count2cpp4rpu-try-by-create2kernel4rpu: " + str(task4kernel2rpu['COUNT4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CPP - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['COUNT4CPP']  = task4kernel2rpu['COUNT4CPP']  
    
            message2print = "{(Step 31B2/70) initialized" + "; count2cpp4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['COUNT4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31B2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cpp4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
            
    
    if 'COUNT4C' in keys2task:               
        message2print = "{(Step 31C1/70) try" + "; count2c4rpu-try-by-create2kernel4rpu: " + str(task4kernel2rpu['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4C - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['COUNT4C']  = task4kernel2rpu['COUNT4C']  
    
            message2print = "{(Step 31C2/70) initialized" + "; count2c4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31C2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2c4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
    
    if 'COUNT4CL' in keys2task:               
        message2print = "{(Step 31D1/70) try" + "; count2cl4rpu-try-by-create2kernel4rpu: " + str(task4kernel2rpu['COUNT4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CL - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['COUNT4CL']  = task4kernel2rpu['COUNT4CL']  
    
            message2print = "{(Step 31D2/70) initialized" + "; count2cl4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['COUNT4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31D2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cl4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
                
    if 'COUNT4PYC' in keys2task:               
        message2print = "{(Step 31E1/70) try" + "; count4pyc-try-by-create2kernel4rpu: " + str(task4kernel2rpu['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PYC - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['COUNT4PYC']  = task4kernel2rpu['COUNT4PYC']  
    
            message2print = "{(Step 31E2/70) initialized" + "; count4pyc-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '31E2-'
        except: 
            message2print = "{(Step 31Z4/70) yielded" + "; count4pyc-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z4-'     
    
    if 'COUNT4BIN' in keys2task:               
        message2print = "{(Step 31F1/70) try" + "; count4bin-try-by-create2kernel4rpu: " + str(task4kernel2rpu['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4BIN - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['COUNT4BIN']  = task4kernel2rpu['COUNT4BIN']  
    
            message2print = "{(Step 31F2/70) initialized" + "; count4bin-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 0
            code2ack  = code2ack + '31F2-'
        except: 
            message2print = "{(Step 31Z5/70) yielded" + "; count4bin-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z5-' 
                            
    if 'DIRECTORY4PY' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A) DIRECTORY4PY - REQUIRED                
            # ---------------------------------------------------------------------------------------------             
            dir2py4rpu = folder2lib4rpu                                                                                                                                                            
            message2print = "{(Step 32A/70) set" + "; dir2py4rpu-set-by-create2kernel4rpu to: " + str(dir2py4rpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4rpu 
            code2ack  = code2ack + '32A-' 
        
            task4kernel2rpu ['DIRECTORY4PY'] = dir2py4rpu
        except: 
            message2print = "{(Step 32AZ/70) yielded" + "; directory4py-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32AZ-'                         
               
    if 'DIRECTORY4PY' in keys2task:
        message2print = "{(Step 32A1/70) try" + "; directory4py-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PY - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['DIRECTORY4PY']  = task4kernel2rpu['DIRECTORY4PY']  
     
            message2print = "{(Step 32B1/70) initialized" + "; directory2py4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4rpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z1/70) yielded" + "; directory2py4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CPP' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CPP - C++                 
            # ---------------------------------------------------------------------------------------------             
            dir2cpp4rpu = folder2lib4rpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cpp4rpu-set-by-create2kernel4rpu to: " + str(dir2cpp4rpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4rpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2rpu ['DIRECTORY4CPP'] = dir2cpp4rpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CPP' in keys2task:
        message2print = "{(Step 32A2/70) try" + "; directory2cpp4rpu-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CPP - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['DIRECTORY4CPP']  = task4kernel2rpu['DIRECTORY4CPP']  
     
            message2print = "{(Step 32B2/70) initialized" + "; directory2cpp4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4rpu
            code2ack  = code2ack + '32B2-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2cpp4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
                         
    if 'DIRECTORY4C' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4C - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2c4rpu = folder2lib4rpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2c4rpu-set-by-create2kernel4rpu to: " + str(dir2c4rpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4rpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2rpu ['DIRECTORY4C'] = dir2c4rpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4C' in keys2task:
        message2print = "{(Step 32A3/70) try" + "; directory2c4rpu-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4C - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['DIRECTORY4C']  = task4kernel2rpu['DIRECTORY4C']  
     
            message2print = "{(Step 32B3/70) initialized" + "; directory2c4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['DIRECTORY4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4rpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2c4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CL' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CL - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2cl4rpu = folder2lib4rpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cl4rpu-set-by-create2kernel4rpu to: " + str(dir2cl4rpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4rpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2rpu ['DIRECTORY4CL'] = dir2cl4rpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CL' in keys2task:
        message2print = "{(Step 32A4/70) try" + "; directory2cl4rpu-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CL - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['DIRECTORY4CL']  = task4kernel2rpu['DIRECTORY4CL']  
     
            message2print = "{(Step 32B4/70) initialized" + "; directory2cl4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['DIRECTORY4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4rpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z4/70) yielded" + "; directory2cl4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-'
              
    if 'DIRECTORY4PYC' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4PYC - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4rpu = folder2lib4rpu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 32B2/70) set" + "; dir2pycache4rpu-set-by-create2kernel4rpu to: " + str(dir2pycache4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4rpu + '__pycache__//'
            code2ack  = code2ack + '32B2-' 
        
            task4kernel2rpu ['DIRECTORY4PYC'] = dir2pycache4rpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'                     
                                                    
    if 'DIRECTORY4PYC' in keys2task:
        message2print = "{(Step 32C/70) try" + "; directory2pyc4rpu-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PYC - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['DIRECTORY4PYC']  = task4kernel2rpu['DIRECTORY4PYC']  
     
            message2print = "{(Step 32D/70) initialized" + "; directory2pyc4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4rpu + __pycache__//
            code2ack  = code2ack + '32D-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z2-' 
             
    if 'DIRECTORY4BIN' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4BIN - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2bin4rpu = folder2lib4rpu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4rpu-set-by-create2kernel4rpu to: " + str(dir2bin4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4rpu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2rpu ['DIRECTORY4BIN'] = dir2bin4rpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4bin-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-' 
                                        
    if 'DIRECTORY4BIN' in keys2task:
        message2print = "{(Step 32E/70) try" + "; directory2bin4rpu-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4BIN - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['DIRECTORY4BIN']  = task4kernel2rpu['DIRECTORY4BIN']  
     
            message2print = "{(Step 32F/70) initialized" + "; directory2bin4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4rpu + bin//
            code2ack  = code2ack + '32F-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2bin4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z3-'  
    
                     
    if 'CODE4PY' in keys2task:            
        message2print = "{(Step 33A1/70) try" + "; code2py4rputask-try-by-create2kernel4rpu: " + str(task4kernel2rpu ['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4rpu + 'rpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: ...
        
        rpu2kernel4xi['CODE4PY'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PY - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['CODE4PY'] = task4kernel2rpu ['CODE4PY']
    
     
            message2print = "{(Step 33B1/70) created" + "; code2py4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + 'rpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2:
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z1/70) yielded" + "; code2py4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE4PY']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2py4rpu2nack  = code2py4rpu2nack + '33Z1-'     
                     
    if 'CODE4CPP' in keys2task:            
        message2print = "{(Step 33A2/70) try" + "; code2cpp4rputask-try-by-create2kernel4rpu: " + str(len(task4kernel2rpu ['CODE4CPP']))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4rpu +  rpu2dummy4xi5test.cpp
        
        rpu2kernel4xi['CODE4CPP'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CPP - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['CODE4CPP'] = task4kernel2rpu ['CODE4CPP']
    
     
            message2print = "{(Step 33B2/70) created" + "; code2cpp4rpu-created-by-create2kernel4rpu: " + str(len(rpu2kernel4xi['CODE4CPP']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + rpu2dummy4xi5test.cpp
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2cpp4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE4CPP']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cpp4rpu2nack  = code2cpp4rpu2nack + '33Z2-'     
                     
    if 'CODE4C' in keys2task:            
        message2print = "{(Step 33A3/70) try" + "; code2c4rputask-try-by-create2kernel4rpu: " + str(task4kernel2rpu ['CODE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4rpu + 
        
        rpu2kernel4xi['CODE4C'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4C - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['CODE4C'] = task4kernel2rpu ['CODE4C']
    
     
            message2print = "{(Step 33B3/70) created" + "; code2c4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2c4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE4C']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2c4rpu2nack  = code2c4rpu2nack + '33Z3-'                             
                     
    if 'CODE4CL' in keys2task:            
        message2print = "{(Step 33A4/70) try" + "; code2cl4rputask-try-by-create2kernel4rpu: " + str(task4kernel2rpu ['CODE4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4rpu + 
        
        rpu2kernel4xi['CODE4CL'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CL - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['CODE4CL'] = task4kernel2rpu ['CODE4CL']
    
     
            message2print = "{(Step 33B4/70) created" + "; code2cl4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z4/70) yielded" + "; code2cl4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE4CL']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cl4rpu2nack  = code2cl4rpu2nack + '33Z1-'     
                                        
    if 'CODE4PYC' in keys2task:            
        message2print = "{(Step 33C/70) try" + "; code2pyc4rpu-try-by-create2kernel4rpu: " + str(task4kernel2rpu ['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4rpu + 
        
        rpu2kernel4xi['CODE4PYC'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['CODE4PYC'] = task4kernel2rpu ['CODE4PYC']
    
     
            message2print = "{(Step 33D/70) created" + "; code2pyc4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + 
             
            code2ack  = code2ack + '33D-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2pyc4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE4PYC']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2pyc4rpu2nack  = code2pyc4rpu2nack + '33Z2-'     
                            
    if 'CODE4BIN' in keys2task:            
        message2print = "{(Step 33E/70) try" + "; code2bin4rpu2bin4rpu-try-by-create2kernel4rpu: " + str(task4kernel2rpu ['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4rpu + 
        
        rpu2kernel4xi['CODE4BIN'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['CODE4BIN'] = task4kernel2rpu ['CODE4BIN']
    
     
            message2print = "{(Step 33F/70) created" + "; code2bin4rpu-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + 
             
            code2ack  = code2ack + '33F-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2bin4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi['CODE4BIN']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2bin4rpu2nack  = code2bin4rpu2nack + '33Z3-'     
            
    if 'SIZE4PY' in keys2task:        
        message2print = "{(Step 34A1/70) try" + "; size2py4rpu-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['SIZE4PY']  = task4kernel2rpu['SIZE4PY']  
     
            message2print = "{(Step 34B1/70) initialized" + "; size2py4rpu-initialized-by-create2kernel4rpu to: " + str(rpu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + 'rpu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z1/70) yielded" + "; size2py4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
            
    if 'SIZE4CPP' in keys2task:        
        message2print = "{(Step 34A2/70) try" + "; size2cpp4rpu-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['SIZE4CPP']  = task4kernel2rpu['SIZE4CPP']  
     
            message2print = "{(Step 34B2/70) initialized" + "; size2cpp4rpu-initialized-by-create2kernel4rpu to: " + str(rpu2kernel4xi['SIZE4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + rpu2dummy4xi5test.cpp': 333}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z2/70) yielded" + "; size2cpp4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4C' in keys2task:        
        message2print = "{(Step 34A3/70) try" + "; size2c4rpu-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['SIZE4C']  = task4kernel2rpu['SIZE4C']  
     
            message2print = "{(Step 34B3/70) initialized" + "; size2c4rpu-initialized-by-create2kernel4rpu to: " + str(rpu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size2c4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4CL' in keys2task:        
        message2print = "{(Step 34A4/70) try" + "; size2cl4rpu-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['SIZE4CL']  = task4kernel2rpu['SIZE4CL']  
     
            message2print = "{(Step 34B4/70) initialized" + "; size2cl4rpu-initialized-by-create2kernel4rpu to: " + str(rpu2kernel4xi['SIZE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size2cl4rpu-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
                                    
                        
    if 'SIZE4PYC' in keys2task:        
        message2print = "{(Step 34E/70) try" + "; size-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34F) SIZE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['SIZE4PYC']  = task4kernel2rpu['SIZE4PYC']  
     
            message2print = "{(Step 34F/70) initialized" + "; size-initialized-by-create2kernel4rpu to: " + str(rpu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + 
            code2ack  = code2ack + '34F-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z3-'     
            
    if 'SIZE4BIN' in keys2task:        
        message2print = "{(Step 34G/70) try" + "; size-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34G) SIZE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            rpu2kernel4xi['SIZE4BIN']  = task4kernel2rpu['SIZE4BIN']  
     
            message2print = "{(Step 34H/70) initialized" + "; size-initialized-by-create2kernel4rpu to: " + str(rpu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4rpu + 
            code2ack  = code2ack + '34H-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z4-'
                 
    if 'LANGUAGE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (35A0) LANGUAGE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2rpu ['LANGUAGE'] = {}
            
            for key2code4rpu in keys2code4rpu:
                name2program4rpu=os.path.splitext(key2code4rpu)                                                     
                key2extension4rpu = name2program4rpu[1]                                                             
                if key2extension4rpu == '.py':                          
                    task4kernel2rpu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4rpu == '.cpp':                          
                    task4kernel2rpu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4rpu == '.c':                          
                    task4kernel2rpu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4rpu == '.cl':                          
                    task4kernel2rpu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4rpu-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-' 
        except: 
            message2print = "{(Step 35Z0/70) yielded" + "; language-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z0-'
                                     
    if 'LANGUAGE' in keys2task:        
        message2print = "{(Step 35A/70) try" + "; language-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (35) LANGUAGE - PYTHON, C++, C, CL                              
            # ---------------------------------------------------------------------------------------------             
                            
            rpu2kernel4xi['LANGUAGE']  = task4kernel2rpu['LANGUAGE']  
     
            message2print = "{(Step 35B/70) initialized" + "; language-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-'
        except: 
            message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z1-'  
                     
    if 'COUNT2REFERENCE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (36A0) COUNT2REFERENCE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            count2reference2rpu  = 1
           
            message2print = "{(Step 36B/70) set" + "; count2reference2rpu-set-by-create2kernel4rpu to: " + str(count2reference2rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '36B-' 
        
            task4kernel2rpu ['COUNT2REFERENCE'] = count2reference2rpu     
        except: 
            message2print = "{(Step 36Z0/70) yielded" + "; count2reference2rpu-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z0-'             
                
    if 'COUNT2REFERENCE' in keys2task:                
        message2print = "{(Step 36A/70) try" + "; count2reference-try-by-create2kernel4rpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (36) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            rpu2kernel4xi['COUNT2REFERENCE']  = task4kernel2rpu['COUNT2REFERENCE']  
     
            message2print = "{(Step 36B/70) initialized" + "; count2reference-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '36B-'
        except: 
            message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z1-' 
                
    if 'PROGRAM' not in keys2task:
        message2print = "{(Step 37/70) warned" + "; keys2task4program-warned-by-create2kernel4rpu: " + " ** " + str(keys2task)  + " ** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:             
            # ---------------------------------------------------------------------------------------------
            # (37A0) PROGRAM - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2rpu ['PROGRAM'] = None
            message2print = "{(Step 37A/70) try" + "; program2rpu-try-by-create2kernel4rpu: " + str(task4kernel2rpu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2rpu ['PROGRAM'] = create2programwithsource4rpu()
                keys2program = task4kernel2rpu ['PROGRAM'].keys()
                
                message2print = "{(Step 37B/70) set" + "; program-set-by-create2kernel4rpu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'PROGRAM', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '37B-'
            except:
                message2print = "{(Step 37Z1/70) failed" + "; task4kernel2rpu-failed-by-create2kernel4rpu: " + str(task4kernel2rpu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '37Z-'    
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; program-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-' 
                            
    if 'PROGRAM' in keys2task:
        message2print = "{(Step 37A/70) try" + "; program-try-by-create2kernel4rpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (37) PROGRAM - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            rpu2kernel4xi['PROGRAM']  = task4kernel2rpu['PROGRAM']  
     
            message2print = "{(Step 37B/70) initialized" + "; program-created-by-create2kernel4rpu: " + str(len(rpu2kernel4xi['PROGRAM']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0 ... 
            
            code2ack  = code2ack + '37B-'
        except: 
            message2print = "{(Step 37Z1/70) yielded" + "; program-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z1-' 
                       
    if 'FUNCTION' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2rpu ['FUNCTION'] = {}
            message2print = "{(Step 38A0/70) set" + "; function4rpu-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2rpu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 38A1/70) set" + "; pythonfunction4rpu-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4rpu  = kb2kernel4rpu ['.py'] ['TAG']
            message2print = "{(Step 38A2/70) using" + "; tag2search4rpu-using-by-create2kernel4rpu: " + str(tag2search4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4rpu    = kb2kernel4rpu ['.py'] ['VALUE']
            message2print = "{(Step 38A3/70) using" + "; value2search4rpu-using-by-create2kernel4rpu: " + str(value2search4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # rpu2sampler4xi5test
            
            attribute2search4rpu= kb2kernel4rpu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 38A4/70) using" + "; attribute2search4rpu-using-by-create2kernel4rpu: " + str(attribute2search4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4rpu in keys2code4rpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4rpu]
                    keys2line4rpu = code2examine4rpu.keys()
                    for key2line4rpu in keys2line4rpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4rpu] [key2line4rpu]
                        # message2print = "{(Step 38A5/70) examining" + "; line2examine4rpu-examining-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4rpu,tag2search4rpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 38B/70) examining" + "; line2function4rpu-examining-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # function = "rpu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4rpu,value2search4rpu)
                            if index2function == -1:
                                message2print = "{(Step 38C/70) skipped" + "; line2function4rpu-skipped-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "set2trace4sampler" ... # function = "rpu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4rpu,attribute2search4rpu)             # ....function = "rpu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 38D/70) warning" + "; line2function4rpu-warning-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 38E/70) accepted" + "; line2examine4rpu-accepted-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ... function = "rpu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4rpu = line2examine4rpu[index2function:index2usage-2]
                                    
                                    task4kernel2rpu ['FUNCTION'] ['.py'] [key2pythonfunction4rpu] = {}                                  

                                    message2print = "{(Step 38F/70) used" + "; key2pythonfunction4rpu-used-by-create2kernel4rpu: " + str(key2pythonfunction4rpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # rpu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '38F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 38Z1/70) failed" + "; task4kernel2rpu-failed-by-create2kernel4rpu: " + str(task4kernel2rpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '38Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (39) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2rpu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 39A0F/70) set" + "; cplusfunction4rpu-set-by-create2kernel4rpu to: " + str(task4kernel2rpu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4rpu      = kb2kernel4rpu ['.cpp'] ['TAG']
            message2print = "{(Step 39A2/70) using" + "; tag2search4rpu-using-by-create2kernel4rpu: " + str(tag2search4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # function =
            
            attribute2search4rpu= kb2kernel4rpu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 39A4/70) using" + "; attribute2search4rpu-using-by-create2kernel4rpu: " + str(attribute2search4rpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4rpu in keys2code4rpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4rpu]
                    message2print = "{(Step 39A5/70) using" + "; key2code4rpu-using-by-create2kernel4rpu: " + str(key2code4rpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # rpu2dummy4xi5test.cpp
                       
                    keys2line4rpu = code2examine4rpu.keys()
                    # message2print = "{(Step 39A6/70) using" + "; keys2line4rpu-using-by-create2kernel4rpu: " + str(keys2line4rpu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4rpu in keys2line4rpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4rpu = task4kernel2rpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4rpu] [key2line4rpu]
                        # message2print = "{(Step 39A7/70) examining" + "; line2examine4rpu-examining-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # function = "nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4rpu,tag2search4rpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 39B1/70) examining" + "; line2function4rpu-examining-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # function = "OCLError" usage = "error code checking"*/
                            # function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 39B2/70) using" + "; attribute2search4rpu-using-by-create2kernel4rpu: " + str(attribute2search4rpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4rpu,attribute2search4rpu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 39C/70) skipped" + "; line2function4rpu-skipped-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 39E/70) accepted" + "; line2examine4rpu-accepted-by-create2kernel4rpu: " + str(line2examine4rpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "nbody_kern" usage = "kernel example 1"*/; 
                                # function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4rpu = line2examine4rpu[27:index2usage-2]  
                                task4kernel2rpu ['FUNCTION'] ['.cpp'] [key2kernelfunction4rpu] =  {}                                       

                                message2print = "{(Step 39F/70) used" + "; key2kernelfunction4rpu-used-by-create2kernel4rpu: " + str(key2kernelfunction4rpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '39F-'
                                    
            except: 
                message2print = "{(Step 37Z1/70) yielded" + "; program-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + '37Z1-'
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; function-rpu2kernel4xi-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-'                               
                
    if 'FUNCTION' in keys2task:    
        message2print = "{(Step 38A/70) trying" + "; function-trying-by-create2kernel4rpu: " + str(task4kernel2rpu['FUNCTION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'.py': {'rpu2sampler4xi5test': {}}, 
        # '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}    
        try:            
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            rpu2kernel4xi['FUNCTION']  = task4kernel2rpu['FUNCTION']   
     
            message2print = "{(Step 38B/70) created" + "; function-created-by-create2kernel4rpu: " + str(rpu2kernel4xi['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'.py': {'rpu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}} 
            
            code2ack  = code2ack + '38B-'
        except: 
            message2print = "{(Step 38Z1/70) yielded" + "; function-yielded-by-create2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '38Z1-'            
                                       
                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)     
    # -----------------------------------------------------------------------------------------
    rpu2kernel4xi ['ACK2RETURN']  = code2ack
    rpu2kernel4xi ['NACK2RETURN'] = code2nack 
     
    keys2kernel4rpu = rpu2kernel4xi.keys()
    message2print = "{(Step 70A/70) returning" + "; keys2kernel4rpu-returning-by-create2kernel4rpu: " + str(keys2kernel4rpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 (no parameters given by caller): 
    # ['DIRECTORY4CL',
    #  'DIRECTORY4PY',
    #  'DIRECTORY4C',
    #  'DIRECTORY4CPP',
    #  'DIRECTORY4PYC',    
    #  'DIRECTORY4BIN',    
    #  'CODE4PY',
    #  'CODE4PYC',
    #  'CODE4CPP',
    #  'CODE4BIN',
    #  'CODE4C',
    #  'CODE4CL',
    #  'COUNT4C',                
    #  'COUNT4CL',    
    #  'COUNT4CPP',
    #  'COUNT4PYC',
    #  'COUNT4PY',
    #  'COUNT4BIN',
    #  'SIZE4PY',    
    #  'SIZE4CPP', <-- OK: C and CL MISSING
    #  'SIZE4PYC',
    #  'SIZE4BIN',
                        
    #  'QUEUE',
    #  'PROGRAM',
    #  'CONTEXT',
    #  'PIPE',
    #  'FUNCTION2CALLBACK',
    #  'COMMANDQUEUE',
    #  'PLATFORM',
    #  'FUNCTION',
    #  'CODE2ERROR',
    #  'ACK2RETURN',
    #  'DATA2CALLBACK',
    #  'BUFFER',
    #  'COUNT2REFERENCE',
    #  'DEVICE',
    #  'LANGUAGE',
    #  'NACK2RETURN',
    #  'EVENT']



    
    #2 (function and program parameters given by user):
    # ['FUNCTION',
    #  'ACK2RETURN',
    #  'PROGRAM',
    #  'NACK2RETURN']

    
    keys2programkernel4rpu = rpu2kernel4xi['PROGRAM'].keys()
    message2print = "{(Step 70B/70) returning" + "; keys2programkernel4rpu-returning-by-create2kernel4rpu: " + str(keys2programkernel4rpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 and 2:
    # ['CODE2ERROR', 'LANGUAGE4SOURCE', 'COUNT4SOURCE' ...
    
    try:
        message2print = "{(Step 70C1/70) returning" + "; count2py4rpu-returning-by-create2kernel4rpu: " + str(rpu2kernel4xi ['COUNT4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C2/70) returning" + "; count2cpp4rpu-returning-by-create2kernel4rpu: " + str(rpu2kernel4xi ['COUNT4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C3/70) returning" + "; count2c4rpu-returning-by-create2kernel4rpu: " + str(rpu2kernel4xi ['COUNT4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
    
    try:
        message2print = "{(Step 70C4/70) returning" + "; count2cl4rpu-returning-by-create2kernel4rpu: " + str(rpu2kernel4xi ['COUNT4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S1/70) returning" + "; size2py4rpu-returning-by-create2kernel4rpu: " + str(rpu2kernel4xi['SIZE4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # pu2sampler4xi5test.py': 1337
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S2/70) returning" + "; size2cpp4rpu-returning-by-create2kernel4rpu: " + str(rpu2kernel4xi['SIZE4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # rpu2dummy4xi5test.cpp': 331
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S3/70) returning" + "; size2c4rpu-returning-by-create2kernel4rpu: " + str(rpu2kernel4xi['SIZE4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S4/70) returning" + "; size2cl4rpu-returning-by-create2kernel4rpu: " + str(rpu2kernel4xi['SIZE4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    


    message2print = "{(Step 70T/70) returning" + "; function2kernel4rpu-returning-by-create2kernel4rpu: " + str(rpu2kernel4xi['FUNCTION']) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # {'.py':  {'rpu2sampler4xi5test': {}},
    #  '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}
    # }  
        
    
                         
    return rpu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "add2kernel4rpu" usage = "
#     
#   print('(Step 3A2/700) OF RPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4add2kernel = {}
#       task4add2kernel ['CODE4KERNEL'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4rpu + 'rpu2dummy4xi.py'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4rpu + 'rpu2dummy4xi.py'] [1] = '... profile = "11" />'
#       task4add2kernel ['SIZE4KERNEL'] = {}
#       task4add2kernel ['SIZE4KERNEL'] [folder2lib4rpu + 'rpu2dummy4xi.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4rpu + 'rpu2dummy4xi.py'])
#       
#       response4add2kernel = add2kernel4rpu(task4add2kernel)
#       print('(Step 3A3/700) OF RPU2KERNEL4XI5TEST - ADDED KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z2/700) OF RPU2KERNEL4XI5TEST *** FAILED TO PRINT response4add2kernel: ', response4add2kernel)
#          
#">

# -------------------------------------------------------------------------------------------------   
def add2kernel4rpu(task4kernel2rpu):

    '''
    adds to kernel for RPU
    '''
    global rpu2kernel4xi                                                                                            # Kernel of RPU    
    global folder2lib4rpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "add2kernel4rpu" 
    method2print = "add2kernel4rpu"

    message2print = "{(Step 10A/70) started" + "; add2kernel4rpu-started: " + str(add2kernel4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2rpu-to-add2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
    code2ack  = ' '
    code2nack = ' ' 
    try:
        keys2kernel4task = task4kernel2rpu ['CODE4KERNEL'].keys()
        message2print = "{(Step 10C/70) using" + "; keys2kernel4task-using-by-add2kernel4rpu: " + str(keys2kernel4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #         
    except: 
        message2print = "{(Step 10Z1/70) failed" + "; keys2kernel4task-failed-by-add2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    try:
        keys2exist4task =  rpu2kernel4xi ['CODE4KERNEL'].keys() 
        message2print = "{(Step 10D/70) using" + "; keys2exist4task-using-by-add2kernel4rpu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    except:
        try:
            response2createwb4rpu = create2kernelsinkernel4rpu()
            keys2createwb4rpu = response2createwb4rpu.keys()
            for key2createwb4rpu in keys2createwb4rpu:
                if key2createwb4rpu == 'CODE4KERNEL':
                    message2print = "{(Step 10E/70) created" + "; key2createwb4rpu-created-by-add2kernel4rpu: " + str(key2createwb4rpu) + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)
                    # 
            
            keys2exist4task =  rpu2kernel4xi ['CODE4KERNEL'].keys() 
            message2print = "{(Step 10F/70) using" + "; keys2exist4task-using-by-add2kernel4rpu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        
        except: 
            message2print = "{(Step 10Z2/70) failed" + "; rpu2kernel4xi-failed-by-add2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - EXPECTED - SEVERAL KERNEL CODE CAN BE ADDED INTO ONE PROGRAM OBJECT                              
        # ---------------------------------------------------------------------------------------------             
        for key2kernel4task in keys2kernel4task:
            try:
                message2print = "{(Step 33A/70) using" + "; key2kernel4task-using-by-add2kernel4rpu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                            
                if key2kernel4task in keys2exist4task:
                    message2print = "{(Step 33Z0/70) yielded" + "; key2kernel4task-yielded-by-add2kernel4rpu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # folder2lib4rpu +  
                     
                    code2nack  = code2nack + '33Z0-'
                else: 
                    try:
                        rpu2kernel4xi ['CODE4KERNEL'] [key2kernel4task] = task4kernel2rpu ['CODE4KERNEL'] [key2kernel4task]
                    except:
                        message2print = "{(Step 33Z1/70) failed" + "; task4kernel2rpu-failed-by-add2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z1-' 
                    try:             
                        message2print = "{(Step 33B/70) added" + "; key2kernel4task-added-by-add2kernel4rpu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        #folder2lib4rpu +  
                    except:
                        message2print = "{(Step 33Z2/70) failed" + "; task4kernel2rpu-failed-by-add2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z2-' 
                    try:             
                        message2print = "{(Step 33C/70) added" + "; code-added-by-add2kernel4rpu to: " + str(rpu2kernel4xi ['CODE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z3/70) failed" + "; task4kernel2rpu-failed-by-add2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        code2nack  = code2nack + '33Z3-'                 
                    try:
                        rpu2kernel4xi ['COUNT4KERNEL'] = rpu2kernel4xi ['COUNT4KERNEL'] + 1
                        message2print = "{(Step 33D/70) added" + "; count4kernel-added-by-add2kernel4rpu to: " + str(rpu2kernel4xi ['COUNT4KERNEL'])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z4/70) failed" + "; task4kernel2rpu-failed-by-add2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z4-' 
                    try:                            
                        rpu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task]  = task4kernel2rpu['SIZE4KERNEL'] [key2kernel4task]  
                        message2print = "{(Step 33E/70) set" + "; size4kernel-set-by-add2kernel4rpu to: " + str(rpu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                        code2ack  = code2ack + '33D-'
                    except:
                        message2print = "{(Step 33Z5/70) failed" + "; task4kernel2rpu-failed-by-add2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z5-'    
            except:
                message2print = "{(Step 33Z6/70) failed" + "; task4kernel2rpu-failed-by-add2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                code2nack  = code2nack + '33Z6-'                     
    except: 
        message2print = "{(Step 33Z7/70) yielded" + "; kernel-yielded-by-add2kernel4rpu: " + str(rpu2kernel4xi ['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '33Z7-'       
          
                                                                                                                   
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    rpu2kernel4xi ['ACK2RETURN']  = code2ack
    rpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernelkernels = rpu2kernel4xi ['CODE4KERNEL'].keys()
    for key2kernelkernel in sorted(keys2kernelkernels):
        message2print = "{(Step 70A/70) got" + "; key2kernelkernel-got-by-add2kernel4rpu: " + str(key2kernelkernel) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        #folder2lib4rpu +  


    keys2kernel4rpu = rpu2kernel4xi.keys()
    for key2kernel4rpu in keys2kernel4rpu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4rpu-returning-by-add2kernel4rpu: " + str(key2kernel4rpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return rpu2kernel4xi
            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2nativekernel4rpu" usage = "
#     
#   print('(Step 2A2/700) OF RPU2KERNEL4XI5TEST - TRYING TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())           
#   try:
#       response4execute = execute2nativekernel4rpu()
#   except:
#       print('(Step 2Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION *** ', time4xi())                                                                      
#          
#">

# -------------------------------------------------------------------------------------------------   
def execute2nativekernel4rpu(task4program2rpu=None):

    '''
    executes native kernel of RPU
    '''
    global rpu2kernel4xi                                                                                            # Kernel of RPU    
    global import2use4rpu                                                                                           # Imports of RPU
    global target2function4rpu                                                                                      # Target function of Process4Xi
    global folder2lib4rpu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2nativekernel4rpu" 
    method2print = "execute2nativekernel4rpu"

    message2print = "{(Step 1A/70) started" + "; execute2nativekernel4rpu-started: " + str(execute2nativekernel4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4program2rpu-to-execute2nativekernel4rpu: " + str(task4program2rpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    kernel2program4rpu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
    message2print = "{(Step 1C/70) initialized" + "; kernel2program4rpu-initialized-by-execute2nativekernel4rpu to: " + str(kernel2program4rpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #                
    try:             
        if task4program2rpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4program2rpu-yielded-by-execute2nativekernel4rpu: " + str(task4program2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - EXECUTE NATIVE KERNELS INSIDE PROGRAM OBJECT FOR RPU ! 
    # ---------------------------------------------------------------------------------------------    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                            
        # ---------------------------------------------------------------------------------------------             
        keys2kernel4rpu = rpu2kernel4xi['CODE4KERNEL'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2kernel4rpu-using-by-execute2nativekernel4rpu: " + str(keys2kernel4rpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        unit4processing = "rpu"
        
        for key2kernel4rpu in keys2kernel4rpu:
            index2search=str.find(key2kernel4rpu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2execute = key2kernel4rpu[index2search:]                                                          # rpu2sampler4xi5test.py
                index2search=str.find(target2execute,".py")
                if index2search == -1:
                    pass
                else:
                    target2execute4rpu = target2execute[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2execute4rpu-set-by-execute2nativekernel4rpu to: " + str(target2execute4rpu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # 

                    p2kernel4rpu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4RPU 
                        # ---------------------------------------------------------------------------------------------    
             
                        try:
                            import2use4rpu.get(target2execute4rpu, handle2error4rpu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2execute4rpu-imported-by-execute2nativekernel4rpu: " + str(target2execute4rpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4rpu-failed-by-execute2nativekernel4rpu: " + str(import2use4rpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2execute4rpu-used-by-execute2nativekernel4rpu: " + str(target2execute4rpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4RPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2rpu = Process4Xi(target=target2function4rpu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2rpu-created-by-execute2nativekernel4rpu: " + str(p2rpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-1, initial)>
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2rpu.start()
                            message2print = "{(Step 34A/70) started" + "; p2rpu-started-by-execute2nativekernel4rpu: " + str(p2rpu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-1
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4rpu = p2rpu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-execute2nativekernel4rpu: " + str(status2process4rpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2rpu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2rpu-run-by-execute2nativekernel4rpu: " + str(p2rpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-execute2nativekernel4rpu: " + str(p2rpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-execute2nativekernel4rpu: " + str(p2rpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-execute2nativekernel4rpu: " + str(p2rpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2kernel4rpu-failed-by-execute2nativekernel4rpu: " + str(p2kernel4rpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    
            # ---------------------------------------------------------------------------------------------
            # SAVE SOURCE WITHOUT END OF LINES
            # ---------------------------------------------------------------------------------------------        
            keys2lines = rpu2kernel4xi['CODE4KERNEL'][key2kernel4rpu].keys()     
            kernel2program4rpu[key2kernel4rpu] = ""
            for key2line in keys2lines:
                code2add4rpu = rpu2kernel4xi ['CODE4KERNEL'] [key2kernel4rpu] [key2line]
                kernel2program4rpu[key2kernel4rpu] = kernel2program4rpu[key2kernel4rpu] + code2add4rpu.replace("\n","")
        
            message2print = "{(Step 34A/70) saved" + "; lenght-kernel4rpu-saved-by-execute2nativekernel4rpu to: " + str(len(kernel2program4rpu[key2kernel4rpu]))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #     
                
 
        message2print = "{(Step 38A/70) set" + "; lenght-kernel2program4rpu-set-by-execute2nativekernel4rpu to: " + str(len(kernel2program4rpu))  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; kernel-yielded-by-execute2nativekernel4rpu: " + str(rpu2kernel4xi['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    rpu2kernel4xi ['ACK2RETURN']  = code2ack
    rpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernel4rpu = kernel2program4rpu.keys()
    for key2kernel4rpu in keys2kernel4rpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4rpu-returning-by-execute2nativekernel4rpu: " + str(key2kernel4rpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        # 
    
    return kernel2program4rpu
            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "delete2kernel4rpu" usage = "
#     
#   print('(Step 3A3/700) OF RPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4delete2kernel = {}
#       task4delete2kernel ['CODE4KERNEL'] = {}
#       task4delete2kernel ['CODE4KERNEL'] [folder2lib4rpu + 'rpu2program4xi.py'] = 'Yes'
#       task4delete2kernel ['SIZE4KERNEL'] = {}
#       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4rpu + 'rpu2program4xi.py'] = 'Yes'
#       
#       response4delete2kernel = delete2kernel4rpu(task4delete2kernel) 
#       print('(Step 3A3/700) OF RPU2KERNEL4XI5TEST - DELETED KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF RPU2KERNEL4XI5TEST *** FAILED TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION *** ', time4xi()) 
#          
#">

# -------------------------------------------------------------------------------------------------   
def delete2kernel4rpu(task4kernel2rpu):

    '''
    deletes kernel for RPU
    '''
    global rpu2kernel4xi                                                                                     
    global folder2lib4rpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "delete2kernel4rpu" 
    method2print = "delete2kernel4rpu"

    message2print = "{(Step 10A/70) started" + "; delete2kernel4rpu-started: " + str(delete2kernel4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function delete2kernel4rpu at 0x000000000405CEC8>
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2rpu-to-delete2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 


    code2ack  = ' '
    code2nack = ' '    
    #
    ack4key2kernelkernel = False
    try:
        # ---------------------------------------------------------------------------------------------
        # TASK MUST HAVE BEEN GIVEN BY USER - CONTAINS KERNEL KEYS    
        # ---------------------------------------------------------------------------------------------
        keys2delete4kernel = task4kernel2rpu ['CODE4KERNEL'].keys()        
        message2print = "{(Step 19A/70) using" + "; keys2delete4kernel-using-by-delete2kernel4rpu: " + str(sorted(keys2delete4kernel))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # ---------------------------------------------------------------------------------------------
        # (Step 20A/70) - DELETE KERNEL INSIDE PROGRAM OBJECT FOR RPU ! 
        # ---------------------------------------------------------------------------------------------    
        message2print = "{(Step 20A0/70) try" + "; key-try-by-delete2kernel4rpu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      

        for key2delete4kernel in keys2delete4kernel:
            try:            
                del rpu2kernel4xi ['CODE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20C/70) deleted" + "; code4kernel-deleted-by-delete2kernel4rpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20C-' 
                
                del rpu2kernel4xi ['SIZE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20D/70) deleted" + "; size4kernel-deleted-by-delete2kernel4rpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20D-' 
                
                rpu2kernel4xi ['COUNT4KERNEL'] = rpu2kernel4xi ['COUNT4KERNEL'] - 1
                message2print = "{(Step 20E/70) upgraded" + "; count4kernel-upgraded-by-delete2kernel4rpu: " + str(rpu2kernel4xi ['COUNT4KERNEL'] ) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                #                                
                
            except:
                message2print = "{(Step 20Z1/70) yielded" + "; key2delete4kernel-yielded-by-delete2kernel4rpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                
                code2nack  = code2nack + '20Z1-' 
    except: 
        message2print = "{(Step 20Z0/70) failed" + "; task4kernel2rpu-rpu2kernel4xi-failed-by-delete2kernel4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '20Z0-'    
                                                                                            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    rpu2kernel4xi ['ACK2RETURN']  = code2ack
    rpu2kernel4xi ['NACK2RETURN'] = code2nack  
    try:
        keys2kernelkernels = rpu2kernel4xi ['CODE4KERNEL'] .keys()
        for key2kernelkernels in keys2kernelkernels:
            message2print = "{(Step 70A/70) got" + "; key2kernelkernels-got-by-delete2kernel4rpu: " + str(key2kernelkernels) + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                              
            #  
    except:
        pass 
               
     
    keys2kernel4rpu = rpu2kernel4xi.keys()
    for key2kernel4rpu in keys2kernel4rpu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4rpu-returning-by-delete2kernel4rpu: " + str(key2kernel4rpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 


    return rpu2kernel4xi
            
#</function4xi> 
 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernelsinprogram4rpu" usage = "
#     
#   print('(Step 3A1/700) OF RPU2KERNEL4XI5TEST - TRYING TO CREATE KERNELS IN PROGRAM FOR RPU ', time4xi())          
#   try:
#       response4create2kernelsinprogram = create2kernelsinprogram4rpu()
#       print('(Step 3A2/700) OF RPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRAM FOR RPU ', time4xi())
#   except:
#       print('(Step 3Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNELS IN PROGRAM FOR RPU *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def create2kernelsinprogram4rpu(task4kernel2rpu=None):

    '''
    creates kernels in program for RPU
    '''
    global rpu2kernel4xi                                                                                            # Kernel of RPU    
    global folder2lib4rpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernelsinprogram4rpu" 
    method2print = "create2kernelsinprogram4rpu"

    message2print = "{(Step 1A/70) started" + "; create2kernelsinprogram4rpu-started: " + str(create2kernelsinprogram4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2rpu-to-create2kernelsinprogram4rpu: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    

    
    keys2kernel4rpu = rpu2kernel4xi.keys()
    for key2kernel4rpu in keys2kernel4rpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4rpu-returning-by-create2kernelsinprogram4rpu: " + str(key2kernel4rpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return rpu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fetch2kernel4rpu" usage = "
#   fetch2kernel4rpu(file2walk)
#"> 
# -------------------------------------------------------------------------------------------------
def fetch2kernel4rpu(program2explore4rpu):
    global fetch2code4rpu                                                                                           # dictionary to receive files 
        
    global kb2fetch4rpu                                                                                             # knowledgebase for fetching
    global profile2fetch                                                                                            # profiles
    global keys2profile4rpu                                                                                         # file extensions 
    
    global folder2lib4rpu  

    class2print  = "fetch2kernel4rpu"
    method2print = "fetch2kernel4rpu" 
     
    message2print = "{(Step 1A/33) passed" + "; program2explore4rpu-passed-to-fetch2kernel4rpu: " + str(program2explore4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # folder2lib4rpu + rpu2buffer4xi.py          ... rpu2sampler4xi5test.py ... rpu2dummy4xi5test.cpp ...           # Python and C++ programs
    # __pycache__\rpu2buffer4xi.cpython-33.pyc   ... rpu2sampler4xi5test.cpython-33.pyc ...                         # Cache of Python binaries
    # //bin\rpu2dummy4xi5test.exe                                                                                   # Built C++ exe files
                  
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program4rpu=os.path.splitext(program2explore4rpu)                                                          # rpu2sampler4xi5test + py

    key2extension4rpu = name2program4rpu[1]                                                                         # py,pyc,cpp,exe 
    message2print = "{(Step 1B/33) set" + "; key2extension4rpu-set-by-fetch2kernel4rpu to: " + str(key2extension4rpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # .py; .pyc
    message2print = "{(Step 1C/33) using" + "; profile2fetch-using-by-fetch2kernel4rpu: " + str(profile2fetch)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # {'.pyc': 'NACK', '.py': 'ACK', '.cpp': 'ACK', '.exe': 'NACK'}  
        
    if profile2fetch [key2extension4rpu] == 'ACK':                                                                  # profile2fetch ['py']  = 'ACK'       
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF FETCH2SCOPE4XI - EXTENSION IN PROFILE 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore4rpu-analyzing-by-fetch2kernel4rpu: " + str(program2explore4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # folder2lib4rpu +  rpu2buffer4xi.py ; rpu2sampler4xi5test.py ...  ... __pycache__\rpu2sampler4xi5test.cpython-33.pyc
        # rpu2dummy4xi5test.cpp
             
        path2input4rpu = program2explore4rpu
        message2print = "{(Step 1B/33) set" + "; path2input4rpu-set-by-fetch2kernel4rpu to: " + str(path2input4rpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # folder2lib4rpu +  rpu2buffer4xi.py ; __pycache__\rpu2sampler4xi5test.cpython-33.pyc; rpu2dummy4xi5test.cpp

        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF FETCH2SCOPE4XI - CHECKING WHETHER PROGRAM MUST BE FETCHED 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A1/33) analyzing" + "; path2input4rpu-analyzing-by-fetch2kernel4rpu: " + str(path2input4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #folder2lib4rpu +  rpu2buffer4xi.py ; rpu2dummy4xi5test.cpp 
            
        keys2fetch4rpu = kb2fetch4rpu.keys()
        message2print = "{(Step 2A2/33) using" + "; keys2fetch4rpu-using-by-fetch2kernel4rpu: " + str(keys2fetch4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #        
        ack2match4file = False
        for key2fecth4rpu in keys2fetch4rpu:                                                                        # 1,2 ...
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------
            index2search=str.find(path2input4rpu,kb2fetch4rpu[key2fecth4rpu])                                       
            if index2search == -1:                                         
                # -----------------------------------------------------------------------------------------
                # VALID FILE TYPE BUT NOT SELECTED TO BE FETCHED - OK ONE MAY ALSO PASS HERE!
                # -----------------------------------------------------------------------------------------               
                message2print = "{(Step 2C1/33) skipped" + "; path2input4rpu-skipped-by-fetch2kernel4rpu: " + str(path2input4rpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                # folder2lib4rpu +  rpu2buffer4xi.py 
                
            else:
                ack2match4file = True
                
                message2print = "{(Step 2D/33) decided" + "; program-to-read-decided-by-fetch2kernel4rpu: " + str(path2input4rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
                #folder2lib4rpu +  rpu2sampler4xi5test.py; __pycache__//rpu2sampler4xi.cpython-33.pyc; 
                #               +  rpu2dummy4xi5test.cpp

                # -----------------------------------------------------------------------------------------
                # (Step 3/33) OF FETCH2SCOPE4XI - OPEN INPUT FILE - READ MODE SET ACCORDING TO FILE TYPE
                # -----------------------------------------------------------------------------------------
                if ((key2extension4rpu == '.py') or (key2extension4rpu == '.cpp') or (key2extension4rpu == '.c') or (key2extension4rpu == '.cl')):
                    file2input4rpu = open(path2input4rpu,'r')
                    message2print = "{(Step 3A/33) opened" + "; file2input4rpu-opened-by-fetch2kernel4rpu: " + str(file2input4rpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # <_io.TextIOWrapper name=folder2lib4rpu + 'rpu2sampler4xi5test.py' mode='r' encoding='cp1252'> 
                     
                if ((key2extension4rpu == '.pyc') or (key2extension4rpu == '.exe')):
                    file2input4rpu = open(path2input4rpu,'rb')
                    message2print = "{(Step 3B/33) opened" + "; file2input4rpu-opened-by-fetch2kernel4rpu: " + str(file2input4rpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    #  __pycache__//rpu2sampler4xi.cpython-33.pyc               
                    
                # -----------------------------------------------------------------------------------------
                # (Step 4/33) OF FETCH2SCOPE4XI - OUTPUT 
                # -----------------------------------------------------------------------------------------
                key2save4rpu = path2input4rpu
                fetch2code4rpu[key2save4rpu] = {}                                                                   # fetch2code4rpu['rpu2sampler4xi5test.py'] = {}
                number2line4rpu = 0  
                message2print = "{(Step 3B/33) saving" + "; key2fecth4rpu-saving-by-fetch2kernel4rpu: " + str(key2fecth4rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
         
                while 1:
                    # -------------------------------------------------------------------------------------
                    # (Step 5/33) OF FETCH2SCOPE4XI - PROCESS FILE
                    # -------------------------------------------------------------------------------------             
                    line2process4rpu = file2input4rpu.readline()  
                    if not line2process4rpu:
                        # ---------------------------------------------------------------------------------
                        # (Step 30/33) OF FETCH2SCOPE4XI - ALL LINES READ, FINISH
                        # ---------------------------------------------------------------------------------             
                        break                                               
                    else:
                        # ---------------------------------------------------------------------------------
                        # (Step 7/33) OF FETCH2SCOPE4XI - SAVE LINE
                        # ---------------------------------------------------------------------------------
                        # message2print = "{(Step 7A/33) read" + "; line2process4rpu-read-by-fetch2kernel4rpu: " + str(line2process4rpu) + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print)              
                        # ... profile = "11" />
                        # ...
                        # # end of rpu2sampler4xi5test.py 
                        # #/> 
                        try:
                            number2line4rpu = number2line4rpu + 1
                            fetch2code4rpu[key2save4rpu][number2line4rpu] = line2process4rpu
                        except:
                            message2print = "{(Step 7Z1/33) failed" + "; key2fecth4rpu-failed-by-fetch2kernel4rpu: " + str(key2fecth4rpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z2/33) failed" + "; line2process4rpu-failed-by-fetch2kernel4rpu: " + str(line2process4rpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z3/33) failed" + "; number2line4rpu-failed-by-fetch2kernel4rpu: " + str(number2line4rpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                                                             
                # -----------------------------------------------------------------------------------------
                # (Step 31/33) OF FETCH2SCOPE4XI - CLOSE INPUT
                # -----------------------------------------------------------------------------------------            
                file2input4rpu.close()
                message2print = "{(Step 31A/33) closed" + "; file2input4rpu-closed-by-fetch2kernel4rpu: " + str(file2input4rpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                # <_io.TextIOWrapper name=folder2lib4rpu + 'rpu2sampler4xi5test.py' mode='r' encoding='cp1252'>     # Python source files
                # {folder2lib4rpu + 'rpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: '# -- 
                # rpu2dummy4xi5test.cpp                                                                             # C++ source files
                # __pycache__//rpu2sampler4xi.cpython-33.pyc                                                        # Cached binary files of Python
                # rpu2dummy4xi5test.exe                                                                             # C++ exe files
        
                message2print = "{(Step 31B1/33) saved" + "; fetch2code4rpu-saved-by-fetch2kernel4rpu: " + str(fetch2code4rpu[key2save4rpu] [1]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... profile = "11" />
                
                message2print = "{(Step 31B2/33) saved" + "; fetch2code4rpu-saved-by-fetch2kernel4rpu: " + str(fetch2code4rpu[key2save4rpu] [2]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # rpu2dummy4xi5test.cpp
                
                message2print = "{(Step 31B3/33) saved" + "; fetch2code4rpu-saved-by-fetch2kernel4rpu: " + str(fetch2code4rpu[key2save4rpu] [3]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... program = "rpu2sampler4xi5test.py">
                
                message2print = "{(Step 31B4/33) saved" + "; fetch2code4rpu-saved-by-fetch2kernel4rpu: " + str(fetch2code4rpu[key2save4rpu] [4]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ...  abstract = "tests rpu2sampler4xi.py"/>
                                                                 
                # ---------------------------------------------------------------------------------------------
                #
                # ---------------------------------------------------------------------------------------------                                          


    else:
        # -----------------------------------------------------------------------------------------
        # FILE TYPE - NOT IN PROFILE
        # -----------------------------------------------------------------------------------------       
        message2print = "{(Step 1F/33) skipped" + "; name2program4rpu-skipped-by-fetch2kernel4rpu: " + str(name2program4rpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # folder2lib4rpu + '__pycache__//rpu2buffer4xi.cpython-32', '.pyc')
        
        extension2skip = name2program4rpu[1]
        message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-fetch2kernel4rpu: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # pyc

        message2print = "{(Step 1H/33) returning" + "; fetch2kernel4rpu-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
 
    message2print = "{(Step 1H/33) returning" + "; fetch2kernel4rpu-returning: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)            
    #   
                                            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernel4rpu" usage = "
#
#   ... prepare task4set2kernelws ...    
#
#   response4set2kernel = {} 
#   print('(Step 17F/700) OF RPU2KERNEL4XI5TEST - TRYING TO SET KERNEL: ', set2kernel4rpu)   
#   # 
#   try:                               
#       response4set2kernel = set2kernel4rpu(task4set2kernelws)
#       print('(Step 17G/700) OF RPU2KERNEL4XI5TEST - SET KERNEL: ', response4set2kernel)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF RPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL: ', set2kernel4rpu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernel4rpu(task4kernelset2rpu=None):

    '''
    sets kernels for RPU
    '''
    global rpu2kernel4xi  
    global folder2lib4rpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernel4rpu"
    method2print = "set2kernel4rpu" 

    message2print = "{(Step 1A/33) started" + "; set2kernel4rpu-started: " + str(set2kernel4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernel4rpu at 0x0000000003837948> 
    
    keys2task = task4kernelset2rpu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernel4rpu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
        
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if rpu2kernel4xi is None:
            rpu2kernel4xi = create2kernel4rpu()                                                                              # INITIALIZE PROGRAM FOR RPU 
            message2print = "{(Step 1C/70) set" + "; rpu2kernel4xi-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4rpu-skipped-by-set2kernel4rpu: " + str(create2kernel4rpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            rpu2kernel4xi = create2kernel4rpu()
            message2print = "{(Step 1E/70) set" + "; rpu2kernel4xi-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            rpu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; rpu2kernel4xi-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['DATA2CALLBACK'] = task4kernelset2rpu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-rpu2kernel4xi-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelset2rpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-rpu2kernel4xi-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['PLATFORM'] = task4kernelset2rpu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-rpu2kernel4xi-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2rpu-try-by-set2kernel4rpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['CONTEXT'] = task4kernelset2rpu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-rpu2kernel4xi-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernel4rpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['DEVICE'] = task4kernelset2rpu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-rpu2kernel4xi-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['CODE2ERROR'] = task4kernelset2rpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-rpu2kernel4xi-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['QUEUE'] = task4kernelset2rpu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-rpu2kernel4xi-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['PIPE'] = task4kernelset2rpu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-rpu2kernel4xi-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernel4rpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['COMMANDQUEUE']  = task4kernelset2rpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernel4rpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        rpu2kernel4xi['BUFFER']  = task4kernelset2rpu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernel4rpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['EVENT']  = task4kernelset2rpu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'
                    
              
    message2print = "{(Step 31A/70) try" + "; count2py4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4PY                           
        # ---------------------------------------------------------------------------------------------             
        rpu2kernel4xi['COUNT4PY']  = task4kernelset2rpu['COUNT4PY']  
 
        message2print = "{(Step 31B/70) set" + "; count2py4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count2py4rpu-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  
                
    message2print = "{(Step 31C/70) try" + "; count2pyc4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31C)  - COUNT4PYC                           
        # ---------------------------------------------------------------------------------------------             
        rpu2kernel4xi['COUNT4PYC']  = task4kernelset2rpu['COUNT4PYC']  
 
        message2print = "{(Step 31D/70) set" + "; count2pyc4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31D-'
    except: 
        message2print = "{(Step 31Z2/70) yielded" + "; count2pyc4rpu-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z2-'  
                
    message2print = "{(Step 31E/70) try" + "; count2c4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31E)  - COUNT4C                           
        # ---------------------------------------------------------------------------------------------             
        rpu2kernel4xi['COUNT4C']  = task4kernelset2rpu['COUNT4C']  
 
        message2print = "{(Step 31F/70) set" + "; count2c4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31F-'
    except: 
        message2print = "{(Step 31Z3/70) yielded" + "; count2c4rpu-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z3-'                  
                
    message2print = "{(Step 31G/70) try" + "; count2bin4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31G)  - COUNT4BIN                           
        # ---------------------------------------------------------------------------------------------             
        rpu2kernel4xi['COUNT4BIN']  = task4kernelset2rpu['COUNT4BIN']  
 
        message2print = "{(Step 31H/70) set" + "; count2bin4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31H-'
    except: 
        message2print = "{(Step 31Z4/70) yielded" + "; count2bin4rpu-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z4-'  
        
    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernel4rpu: " + str(task4kernelset2rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 
    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (32B) DIRECTORY4PY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        rpu2kernel4xi['DIRECTORY4PY']  = task4kernelset2rpu['DIRECTORY4PY'] 
        
        message2print = "{(Step 32B/70) set" + "; directory2py4rpu-set-by-set2kernelwithdirectory2py4rpu4rpu to: " + str(rpu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory2py4rpu-yielded-by-set2kernelwithdirectory2py4rpu4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32C) DIRECTORY4PYC - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        rpu2kernel4xi['DIRECTORY4PYC']  = task4kernelset2rpu['DIRECTORY4PYC'] 
        
        message2print = "{(Step 32C/70) set" + "; directory2pyc4rpu-set-by-set2kernelwithdirectory2pyc4rpu4rpu to: " + str(rpu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32C-'
    except: 
        message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4rpu-yielded-by-set2kernelwithdirectory2pyc4rpu4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z2-'

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32D) DIRECTORY4C - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        rpu2kernel4xi['DIRECTORY4CPP']  = task4kernelset2rpu['DIRECTORY4CPP'] 
        
        message2print = "{(Step 32D/70) set" + "; directory2c4rpu-set-by-set2kernelwithdirectory2c4rpu4rpu to: " + str(rpu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32D-'
    except: 
        message2print = "{(Step 32Z3/70) yielded" + "; directory2c4rpu-yielded-by-set2kernelwithdirectory2c4rpu4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z3-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32E) DIRECTORY4BIN - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        rpu2kernel4xi['DIRECTORY4BIN']  = task4kernelset2rpu['DIRECTORY4BIN'] 
        
        message2print = "{(Step 32E/70) set" + "; directory2bin4rpu-set-by-set2kernelwithdirectory2bin4rpu4rpu to: " + str(rpu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32E-'
    except: 
        message2print = "{(Step 32Z4/70) yielded" + "; directory2bin4rpu-yielded-by-set2kernelwithdirectory2bin4rpu4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z34-'         
                         
    message2print = "{(Step 33A/70) try" + "; code2py4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33B) CODE4PY - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['CODE4PY']  = task4kernelset2rpu['CODE4PY']  
 
        message2print = "{(Step 33B/70) set" + "; code2py4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4rpu + 'rpu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernel = "rpu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code2py4rpu-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2py4rpu2nack  = code2py4rpu2nack + '33Z1-'        
                         
    message2print = "{(Step 33C/70) try" + "; code2c4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33C) CODE4C - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['CODE4CPP']  = task4kernelset2rpu['CODE4CPP']  
 
        message2print = "{(Step 33D/70) set" + "; code2c4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['CODE4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4rpu + 
 
        code2c4rpu2ack  = code2c4rpu2ack + '33D-'
    except: 
        message2print = "{(Step 33Z2/70) yielded" + "; code2c4rpu-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2c4rpu2nack  = code2c4rpu2nack + '33Z2-'                     
                         
    message2print = "{(Step 33D/70) try" + "; code2pyc4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4PYC - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['CODE4PYC']  = task4kernelset2rpu['CODE4PYC']  
 
        message2print = "{(Step 33E/70) set" + "; code2pyc4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4rpu + 
 
        code2pyc4rpu2ack  = code2pyc4rpu2ack + '33E-'
    except: 
        message2print = "{(Step 33Z3/70) yielded" + "; code2pyc4rpu-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2pyc4rpu2nack  = code2pyc4rpu2nack + '33Z3-'        
                         
    message2print = "{(Step 33F/70) try" + "; code2bin4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4BIN - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['CODE4BIN']  = task4kernelset2rpu['CODE4BIN']  
 
        message2print = "{(Step 33G/70) set" + "; code2bin4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4rpu + 
 
        code2bin4rpu2ack  = code2bin4rpu2ack + '33G-'
    except: 
        message2print = "{(Step 33Z4/70) yielded" + "; code2bin4rpu-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2bin4rpu2nack  = code2bin4rpu2nack + '33Z4-'                
                
    message2print = "{(Step 34A/70) try" + "; size2py4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34B) SIZE4PY - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['SIZE4PY']  = task4kernelset2rpu['SIZE4PY']  
 
        message2print = "{(Step 34B/70) set" + "; size2py4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size2py4rpu-yielded-by-set2kernel4rpu: " + str(task4kernelset2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 34C/70) try" + "; size2c4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34C) SIZE4C - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['SIZE4C']  = task4kernelset2rpu['SIZE4C']  
 
        message2print = "{(Step 34D/70) set" + "; size2c4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34D-'
    except: 
        message2print = "{(Step 34Z2/70) yielded" + "; size2c4rpu-yielded-by-set2kernel4rpu: " + str(task4kernelset2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z2-'
                
    message2print = "{(Step 34E/70) try" + "; size2pyc4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34E) SIZE4PYC - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['SIZE4PYC']  = task4kernelset2rpu['SIZE4PYC']  
 
        message2print = "{(Step 34F/70) set" + "; size2pyc4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34F-'
    except: 
        message2print = "{(Step 34Z3/70) yielded" + "; size2pyc4rpu-yielded-by-set2kernel4rpu: " + str(task4kernelset2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z3-'          
                
    message2print = "{(Step 34G/70) try" + "; size2bin4rpu-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34G) SIZE4BIN - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['SIZE4BIN']  = task4kernelset2rpu['SIZE4BIN']  
 
        message2print = "{(Step 34H/70) set" + "; size2bin4rpu-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34H-'
    except: 
        message2print = "{(Step 34Z4/70) yielded" + "; size2bin4rpu-yielded-by-set2kernel4rpu: " + str(task4kernelset2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z4-'  
        
    
                                  
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE (DICTIONARY) - REQUIRED                     
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['LANGUAGE']  = task4kernelset2rpu['LANGUAGE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernel4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['COUNT2REFERENCE']  = task4kernelset2rpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernel4rpu to: " + str(rpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    rpu2kernel4xi ['ACK2RETURN']  = code2ack
    rpu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernel4rpu = rpu2kernel4xi.keys()
    for key2kernel4rpu in keys2kernel4rpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4rpu-returning-by-set2kernel4rpu: " + str(key2kernel4rpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return rpu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelarg4rpu" usage = "
#
#   ... prepare task4set2kernelargws ...    
#
#   response4set2kernelarg = {} 
#   print('(Step 17F/700) OF RPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS : ', set2kernelarg4rpu)   
#   # <function set2kernelarg4rpu at 0x0000000003837948>
#   try:                               
#       response4set2kernel = set2kernelarg4rpu(task4set2kernelargws)
#       print('(Step 17G/700) OF RPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS: ', set2kernelarg4rpu)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF RPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS: ', set2kernelarg4rpu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernelarg4rpu(task4kernelargset2rpu=None):

    '''
    sets kernel arguments for RPU
    '''
    global rpu2kernel4xi  
    global folder2lib4rpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernelarg4rpu"
    method2print = "set2kernelarg4rpu" 

    message2print = "{(Step 1A/33) started" + "; set2kernelarg4rpu-started: " + str(set2kernelarg4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernelarg4rpu at 0x0000000003837948> 
    
    keys2task = task4kernelargset2rpu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernelarg4rpu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
          
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if rpu2kernel4xi is None:
            rpu2kernel4xi = create2kernel4rpu()                                                                              # INITIALIZE PROGRAM FOR RPU 
            message2print = "{(Step 1C/70) set" + "; rpu2kernel4xi-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4rpu-skipped-by-set2kernelarg4rpu: " + str(create2kernel4rpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            rpu2kernel4xi = create2kernel4rpu()
            message2print = "{(Step 1E/70) set" + "; rpu2kernel4xi-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            rpu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; rpu2kernel4xi-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernelarg4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['DATA2CALLBACK'] = task4kernelargset2rpu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-rpu2kernel4xi-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernelarg4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelargset2rpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-rpu2kernel4xi-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernelarg4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['PLATFORM'] = task4kernelargset2rpu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-rpu2kernel4xi-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2rpu-try-by-set2kernelarg4rpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['CONTEXT'] = task4kernelargset2rpu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-rpu2kernel4xi-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernelarg4rpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['DEVICE'] = task4kernelargset2rpu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-rpu2kernel4xi-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernelarg4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['CODE2ERROR'] = task4kernelargset2rpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-rpu2kernel4xi-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernelarg4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['QUEUE'] = task4kernelargset2rpu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-rpu2kernel4xi-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernelarg4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['PIPE'] = task4kernelargset2rpu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-rpu2kernel4xi-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernelarg4rpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['COMMANDQUEUE']  = task4kernelargset2rpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernelarg4rpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        rpu2kernel4xi['BUFFER']  = task4kernelargset2rpu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernelarg4rpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['EVENT']  = task4kernelargset2rpu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'            
                
    message2print = "{(Step 31A/70) try" + "; count4source-try-by-set2kernelarg4rpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4SOURCE                           
        # ---------------------------------------------------------------------------------------------             
        rpu2kernel4xi['COUNT4SOURCE']  = task4kernelargset2rpu['COUNT4SOURCE']  
 
        message2print = "{(Step 31B/70) set" + "; count4source-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['COUNT4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count4source-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  

    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernelarg4rpu: " + str(task4kernelargset2rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'CODE2ERROR': 0 ... 'DIRECTORY4SOURCE': '...//a' ... 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32) DIRECTORY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        rpu2kernel4xi['DIRECTORY4SOURCE']  = task4kernelargset2rpu['DIRECTORY4SOURCE'] 
        
        message2print = "{(Step 32B/70) set" + "; directory-set-by-set2kernelargwithdirectory4rpu to: " + str(rpu2kernel4xi['DIRECTORY4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # OK
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory-yielded-by-set2kernelargwithdirectory4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 
        
    message2print = "{(Step 33A/70) try" + "; code-try-by-set2kernelarg4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['CODE4SOURCE']  = task4kernelargset2rpu['CODE4SOURCE']  
 
        message2print = "{(Step 33B/70) set" + "; code-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['CODE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4rpu + 'rpu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernelarg = "rpu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '33Z1-'             
        
    message2print = "{(Step 34A/70) try" + "; size-try-by-set2kernelarg4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34) SIZE - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['SIZE4SOURCE']  = task4kernelargset2rpu['SIZE4SOURCE']  
 
        message2print = "{(Step 34B/70) set" + "; size-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['SIZE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size-yielded-by-set2kernelarg4rpu: " + str(task4kernelargset2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernelarg4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['LANGUAGE4SOURCE']  = task4kernelargset2rpu['LANGUAGE4SOURCE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['LANGUAGE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernelarg4rpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        rpu2kernel4xi['COUNT2REFERENCE']  = task4kernelargset2rpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernelarg4rpu to: " + str(rpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernelarg4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    rpu2kernel4xi ['ACK2RETURN']  = code2ack
    rpu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernelarg4rpu = rpu2kernel4xi.keys()
    for key2kernelarg4rpu in keys2kernelarg4rpu:
        message2print = "{(Step 70/70) returning" + "; key2kernelarg4rpu-returning-by-set2kernelarg4rpu: " + str(key2kernelarg4rpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return rpu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2kernel4rpu" usage = "
#
#   task4release2kernel  = {} 
#   task4release2kernel  ['COUNT2REFERENCE'] = 1 
#   response4release2kernel = {}
#   
#   print('(Step 18A/700) OF RPU2KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF RPU DEVICE ', time4xi())    
#   try:                               
#       response4release2kernel = release2kernel4rpu(task4release2kernel)
#       print('(Step 18B/700) OF RPU2KERNEL4XI5TEST - RELEASED KERNEL OF RPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 18Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF RPU DEVICE ', time4xi())                                                                                                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def release2kernel4rpu(task4release2rpu=None):

    '''
    releases kernel for RPU
    '''
    global rpu2kernel4xi  
    global folder2lib4rpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2kernel4rpu"
    method2print = "release2kernel4rpu" 

    message2print = "{(Step 1A/33) started" + "; release2kernel4rpu-started: " + str(release2kernel4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4release2rpu-to-release2kernel4rpu: " + str(task4release2rpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    

    code2ack  = ' '
    code2nack = ' '

    try:
        if rpu2kernel4xi is None:
            rpu2kernel4xi = create2kernel4rpu()                                                                       # INITIALIZE KERNEL                 
    except:
        try:
            rpu2kernel4xi = create2kernel4rpu()
        except:
            rpu2kernel4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; rpu2kernel4xi-yielded-by-release2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2kernel4rpu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2rpu is None:
        task4release2rpu = {}
        task4release2rpu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        rpu2kernel4xi['COUNT2REFERENCE'] = rpu2kernel4xi['COUNT2REFERENCE'] - task4release2rpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2kernel4rpu: " + str(rpu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        if rpu2kernel4xi['COUNT2REFERENCE'] < 0:
            rpu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2kernel4rpu: " + " ** " + str(rpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
             
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            rpu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2kernel4rpu: " + " ** " + str(rpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; rpu2kernel4xi-yielded-by-release2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    rpu2kernel4xi ['ACK2RETURN']  = code2ack
    rpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2program4rpu = rpu2kernel4xi.keys()
    for key2program4rpu in keys2program4rpu:
        message2print = "{(Step 70/70) returning" + "; key2program4rpu-returning-by-release2kernel4rpu: " + str(key2program4rpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return rpu2kernel4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2kernel4rpu" usage = "
#
#   task4retain2kernel  = {} 
#   task4retain2kernel  ['COUNT2REFERENCE'] = 1 
#   response4retain2kernel = {}
#   
#   print('(Step 19A/700) OF RPU2KERNEL4XI5TEST - TRYING TO RETAIN PROGRAM OF RPU DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4retain2kernel = retain2kernel4rpu(task4retain2kernel)
#       print('(Step 19B/700) OF RPU2KERNEL4XI5TEST - RETAINED PROGRAM OF RPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 19Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO RETAIN PROGRAM OF RPU DEVICE ', time4xi())                                                                                                  
#
#">

# -------------------------------------------------------------------------------------------------   
def retain2kernel4rpu(task4retain2rpu=None):

    '''
    retains kernel of RPU
    '''
    global rpu2kernel4xi 
    global folder2lib4rpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2kernel4rpu"
    method2print = "retain2kernel4rpu"

    message2print = "{(Step 1A/33) started" + "; retain2kernel4rpu-started: " + str(retain2kernel4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2rpu-to-retain2kernel4rpu: " + str(task4retain2rpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/70) - PROVIDE TASKS, IF NECESSARY AND CHECK GIVEN TASKS 
    # -----------------------------------------------------------------------------------------    
    if task4retain2rpu is None:
        task4retain2rpu = {}
        task4retain2rpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 2A/33) set" + "; task4retain2rpu-set-by-retain2kernel4rpu to: " + str(task4retain2rpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    else:
        pass

    
    # -----------------------------------------------------------------------------------------
    # (Step 3/70) - CHECK COUNT2REFERENCE
    # -----------------------------------------------------------------------------------------         
    if 'COUNT2REFERENCE' in task4retain2rpu.keys():
        pass
    else:
        task4retain2rpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3A/33) set" + "; count2reference-set-by-retain2kernel4rpu to: " + str(task4retain2rpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                   
    if task4retain2rpu['COUNT2REFERENCE'] < 1:
        task4retain2rpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3B/33) set" + "; count2reference-set-by-retain2kernel4rpu to: " + str(task4retain2rpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
        
    # -----------------------------------------------------------------------------------------
    # (Step 4/70) - INITIALIZE PROGRAM IF NECESSARY
    # -----------------------------------------------------------------------------------------
    try:
        if rpu2kernel4xi is None:
            rpu2kernel4xi = create2kernel4rpu()
            message2print = "{(Step 4A/70) created" + "; rpu2kernel4xi-created-by-retain2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                                          
    except:
        try:
            rpu2kernel4xi = create2kernel4rpu()
            message2print = "{(Step 4B/70) created" + "; rpu2kernel4xi-created-by-retain2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
        except:
            rpu2kernel4xi = {}
            message2print = "{(Step 4Z/70) yielded" + "; rpu2kernel4xi-yielded-by-retain2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z-' 


    # -----------------------------------------------------------------------------------------
    # (Step 5/70) - RETAIN
    # -----------------------------------------------------------------------------------------             
    try:
        rpu2kernel4xi['COUNT2REFERENCE'] = rpu2kernel4xi['COUNT2REFERENCE'] + task4retain2rpu['COUNT2REFERENCE']
        message2print = "{(Step 6A/70) calculated" + "; count2reference-calculated-by-retain2kernel4rpu: " + str(rpu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1            
        if rpu2kernel4xi['COUNT2REFERENCE'] <= 0:
            rpu2kernel4xi['COUNT2REFERENCE'] = 1
            message2print = "{(Step 6Z1/70) warning" + "; count2reference-warning-by-retain2kernel4rpu: " + " ** " + str(rpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            code2nack  = code2nack + '6Z1-'
        else:
            code2ack  = code2ack + '6C-'

    except:
        try:
            rpu2kernel4xi['COUNT2REFERENCE'] = 1
        
            message2print = "{(Step 7Z1/70) warning" + "; count2reference-warning-by-retain2kernel4rpu: " + " ** " + str(rpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '7Z1-'
        
        except:
            message2print = "{(Step 7Z2/70) yielded" + "; rpu2kernel4xi-yielded-by-retain2kernel4rpu: " + str(rpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z2-'
        
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70) - RETURN           
    # -----------------------------------------------------------------------------------------
    
    rpu2kernel4xi ['ACK2RETURN']  = code2ack
    rpu2kernel4xi ['NACK2RETURN'] = code2nack     
     
    keys2program4rpu = rpu2kernel4xi.keys()
    for key2program4rpu in keys2program4rpu:
        message2print = "{(Step 70/70) returning" + "; key2program4rpu-returning-by-retain2kernel4rpu: " + str(key2program4rpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return rpu2kernel4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelinfo4rpu" usage = "
#
#   print('(Step 3B1/700) OF RPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFORMATION FOR RPU ', time4xi())     
#   try:
#       response4kernelinfo2rpu = get2kernelinfo4rpu() 
#       print('(Step 3B2/700) OF RPU2KERNEL4XI5TEST - GOT KERNEL INFORMATION FOR RPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF RPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFORMATION FOR RPU', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelinfo4rpu(task4getinfo2kernel=None):

    '''
    gets kernel information of RPU
    '''
    
    global rpu2kernel4xi
    global folder2lib4rpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelinfo4rpu"
    method2print = "get2kernelinfo4rpu"

    message2print = "{(Step 0A/33) started" + "; get2kernelinfo4rpu-started: " + str(get2kernelinfo4rpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelinfo4rpu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    rpu2kernel = {}
    try: 
        if rpu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR RPU           
            # -------------------------------------------------------------------------------------           
            rpu2kernel = create2kernel4rpu()
            message2print = "{(Step 1B2/33) initialized" + "; rpu2kernel-initialized-by-get2kernelinfo4rpu to: " + str(rpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; rpu2kernel4xi-using-by-get2kernelinfo4rpu: " + str(rpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF RPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            rpu2kernel = rpu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; rpu2kernel-got-by-get2kernelinfo4rpu: " + str(rpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF RPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4rpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                rpu2kernel [key2task] = rpu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-rpu2kernel-set-by-get2kernelinfo4rpu to: " + str(rpu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4rpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4rpu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; rpu2kernel4xi-using-by-get2kernel4rpu: " + str(rpu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            rpu2kernel = create2kernel4rpu()
            
            message2print = "{(Step 1F/33) initialized" + "; rpu2kernel-initialized-by-get2kernelinfo4rpu to: " + str(rpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                rpu2kernel = rpu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; rpu2kernel-set-by-get2kernelinfo4rpu to: " + str(rpu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4rpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        rpu2kernel [key2task] = rpu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-rpu2kernel -set-by-get2kernelinfo4rpu to: " + str(rpu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4rpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            rpu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; rpu2kernel-yielded-by-get2kernel4rpu: " + str(rpu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4rpu = rpu2kernel4xi.keys()
    for key2kernel4rpu in keys2kernel4rpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4rpu-returning-by-get2kernelinfo4rpu: " + str(key2kernel4rpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # CODE2ERROR ...
        
    return rpu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelarginfo4rpu" usage = "
#
#   print('(Step 3B1/700) OF RPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENTGS INFO FOR RPU ', time4xi())     
#   try:
#       response4kernelinfo2rpu = get2kernelarginfo4rpu(task4getinfo2kernel) 
#       print('(Step 3B2/700) OF RPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENTGS INFO FOR RPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF RPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENTGS INFO FOR RPU ', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelarginfo4rpu(task4getinfo2kernel=None):

    '''
    gets kernel argument information of RPU
    '''
    
    global rpu2kernel4xi
    global folder2lib4rpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelarginfo4rpu"
    method2print = "get2kernelarginfo4rpu"

    message2print = "{(Step 0A/33) started" + "; get2kernelarginfo4rpu-started: " + str(get2kernelarginfo4rpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelarginfo4rpu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    rpu2kernel = {}
    try: 
        if rpu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR RPU           
            # -------------------------------------------------------------------------------------           
            rpu2kernel = create2kernel4rpu()
            message2print = "{(Step 1B2/33) initialized" + "; rpu2kernel-initialized-by-get2kernelarginfo4rpu to: " + str(rpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; rpu2kernel4xi-using-by-get2kernelarginfo4rpu: " + str(rpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF RPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            rpu2kernel = rpu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; rpu2kernel-got-by-get2kernelarginfo4rpu: " + str(rpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF RPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4rpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                rpu2kernel [key2task] = rpu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-rpu2kernel-set-by-get2kernelarginfo4rpu to: " + str(rpu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4rpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4rpu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; rpu2kernel4xi-using-by-get2kernel4rpu: " + str(rpu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            rpu2kernel = create2kernel4rpu()
            
            message2print = "{(Step 1F/33) initialized" + "; rpu2kernel-initialized-by-get2kernelarginfo4rpu to: " + str(rpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                rpu2kernel = rpu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; rpu2kernel-set-by-get2kernelarginfo4rpu to: " + str(rpu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4rpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        rpu2kernel [key2task] = rpu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-rpu2kernel -set-by-get2kernelarginfo4rpu to: " + str(rpu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4rpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            rpu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; rpu2kernel-yielded-by-get2kernel4rpu: " + str(rpu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4rpu = rpu2kernel4xi.keys()
    for key2kernel4rpu in keys2kernel4rpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4rpu-returning-by-get2kernelarginfo4rpu: " + str(key2kernel4rpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return rpu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2buildinfo4rpu" usage = "
#
#   response4get2buildinfo = get2buildinfo4rpu()
#            
#">

# -------------------------------------------------------------------------------------------------   
def get2buildinfo4rpu(task4getinfo2build=None):

    '''
    gets rpu2build4xi and rpu2build4xi
    '''
    
    global rpu2build4xi
    global folder2lib4rpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2buildinfo4rpu"
    method2print = "get2buildinfo4rpu"

    message2print = "{(Step 0A/33) started" + "; get2buildinfo4rpu-started: " + str(get2buildinfo4rpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2build-passed-to-get2buildinfo4rpu: " + str(task4getinfo2build) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    rpu2build = {}
    try: 
        if rpu2build4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR RPU           
            # -------------------------------------------------------------------------------------           
            rpu2build = {}
            message2print = "{(Step 1B2/33) initialized" + "; rpu2build-initialized-by-get2buildinfo4rpu to: " + str(rpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; rpu2build4xi-using-by-get2buildinfo4rpu: " + str(rpu2build4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF RPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2build is None:
            task4getinfo2build = {}
            rpu2build = rpu2build4xi
            message2print = "{(Step 1C/33) using" + "; rpu2build-got-by-get2buildinfo4rpu: " + str(rpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4buildinfo = task4getinfo2build.keys()
        keys2task = task4getinfo2build.keys()
            
        # -------------------------------------------------------------------------------------
        # BUILD INFO OF RPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2build4rpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                rpu2build [key2task] = rpu2build4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-rpu2build-set-by-get2buildinfo4rpu to: " + str(rpu2build [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2build4rpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2build-using-by-get2build4rpu: " + str(task4getinfo2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; rpu2build4xi-using-by-get2build4rpu: " + str(rpu2build4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE BUILD           
            # -------------------------------------------------------------------------------------           
            rpu2build = {}
            message2print = "{(Step 1F/33) initialized" + "; rpu2build-initialized-by-get2buildinfo4rpu to: " + str(rpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2build is None:
                rpu2build = rpu2build4xi
                message2print = "{(Step 1G/33) set" + "; rpu2build-set-by-get2buildinfo4rpu to: " + str(rpu2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2build.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2build4rpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        rpu2build [key2task] = rpu2build4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-rpu2build -set-by-get2buildinfo4rpu to: " + str(rpu2build  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2build4rpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            rpu2build = {}
            message2print = "{(Step 1Z3/70) yielded" + "; rpu2build-yielded-by-get2build4rpu: " + str(rpu2build) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; rpu2build-returning-by-get2buildinfo4rpu: " + str(rpu2build) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
    
    return rpu2build
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelworkgroupinfo4rpu" usage = "
#     
#   print('(Step 2AB2/700) OF RPU2KERNEL4XI5TEST - TRYING TO GET KERNEL WORK GROUP INFORMATION ', time4xi())           
#   try:
#       response4link = get2kernelworkgroupinfo4rpu()
#       print('(Step 2BB2/700) OF RPU2KERNEL4XI5TEST - GOT KERNEL WORK GROUP INFORMATION ', time4xi()) 
#   except:
#       print('(Step 2Z2/700) OF RPU2KERNEL4XI5TEST *** FAILED TO KERNEL WORK GROUP INFORMATION ', time4xi())                                                                     
#          
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelworkgroupinfo4rpu(task4kernelworkgroupinfo2rpu=None):

    '''
    gets kernel workgroup info of RPU
    '''
    global rpu2kernel4xi                                                                                            # Kernel of RPU    
    global import2use4rpu                                                                                           # Imports of RPU
    global target2function4rpu                                                                                      # Target function of Process4Xi
    global folder2lib4rpu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelworkgroupinfo4rpu" 
    method2print = "get2kernelworkgroupinfo4rpu"

    message2print = "{(Step 1A/70) started" + "; get2kernelworkgroupinfo4rpu-started: " + str(get2kernelworkgroupinfo4rpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernelworkgroupinfo2rpu-to-get2kernelworkgroupinfo4rpu: " + str(task4kernelworkgroupinfo2rpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    process2kernelworkgroupinfo4rpu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernelworkgroupinfo2rpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernelworkgroupinfo2rpu-yielded-by-get2kernelworkgroupinfo4rpu: " + str(task4kernelworkgroupinfo2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - LINK SOURCES INSIDE PROGRAM OBJECT FOR RPU ! 
    # ---------------------------------------------------------------------------------------------    
    process2kernelworkgroupinfo4rpu = {}                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; process2kernelworkgroupinfo4rpu-initialized-by-get2kernelworkgroupinfo4rpu to: " + str(process2kernelworkgroupinfo4rpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}

    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                  
        # ---------------------------------------------------------------------------------------------             
        keys2code4rpu = rpu2kernel4xi['CODE4SOURCE'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2code4rpu-using-by-get2kernelworkgroupinfo4rpu: " + str(keys2code4rpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # dict_keys([folder2lib4rpu + 'rpu2sampler4xi5test.py'])
        
        unit4processing = "rpu"
        
        for key2code4rpu in keys2code4rpu:
            index2search=str.find(key2code4rpu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2link = key2code4rpu[index2search:]                                                          # rpu2sampler4xi5test.py
                index2search=str.find(target2link,".py")
                if index2search == -1:
                    pass
                else:
                    target2link4rpu = target2link[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2link4rpu-set-by-get2kernelworkgroupinfo4rpu to: " + str(target2link4rpu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # rpu2sampler4xi5test

                    p2code4rpu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4RPU 
                        # ---------------------------------------------------------------------------------------------    
      
                        try:
                            import2use4rpu.get(target2link4rpu, handle2error4rpu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2link4rpu-imported-by-get2kernelworkgroupinfo4rpu: " + str(target2link4rpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # rpu2sampler4xi5test
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4rpu-failed-by-get2kernelworkgroupinfo4rpu: " + str(import2use4rpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2link4rpu-used-by-get2kernelworkgroupinfo4rpu: " + str(target2link4rpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4RPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2rpu = Process4Xi(target=target2function4rpu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2rpu-created-by-get2kernelworkgroupinfo4rpu: " + str(p2rpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-2, initial)>
                        
                        process2kernelworkgroupinfo4rpu[key2code4rpu] = p2rpu
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2rpu.start()
                            message2print = "{(Step 34A/70) started" + "; p2rpu-started-by-get2kernelworkgroupinfo4rpu: " + str(p2rpu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-2
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4rpu = p2rpu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-get2kernelworkgroupinfo4rpu: " + str(status2process4rpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2rpu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2rpu-run-by-get2kernelworkgroupinfo4rpu: " + str(p2rpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-get2kernelworkgroupinfo4rpu: " + str(p2rpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-get2kernelworkgroupinfo4rpu: " + str(p2rpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-get2kernelworkgroupinfo4rpu: " + str(p2rpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2code4rpu-failed-by-get2kernelworkgroupinfo4rpu: " + str(p2code4rpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    

 
        message2print = "{(Step 38A/70) set" + "; process2kernelworkgroupinfo4rpu-set-by-get2kernelworkgroupinfo4rpu to: " + str(process2kernelworkgroupinfo4rpu)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; code-yielded-by-get2kernelworkgroupinfo4rpu: " + str(rpu2kernel4xi['CODE4SOURCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    rpu2kernel4xi ['ACK2RETURN']  = code2ack
    rpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; process2kernelworkgroupinfo4rpu-returning-by-get2kernelworkgroupinfo4rpu: " + str(process2kernelworkgroupinfo4rpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 
    return process2kernelworkgroupinfo4rpu
            
#</function4xi> 
 
                                        
# =================================================================================================
#<class4xi class = "RPU2Kernel4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for RPU kernels" usage = "Kernel4Xi of RPU"
#>

# =================================================================================================
class RPU2Kernel4Xi(object): 
    ''' 
    RPU2Kernel4Xi offers  methods for RPU kernels
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2rpu = cpu_corecount4xi()
    #"
    #/>
       
       
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'add2kernel',                      # ACK              

            'execute2kernel',                  # ACK 5.8    p169                                             
            'execute2task',                    # ACK 5.8    p172   
            'execute2nativekernel',            # ACK 5.8    p174     
            
            'create2kernel',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram',         # ACK 5.7.1  p158  
                       
            'delete2kernel',                   # ACK

            'fetch2kernel',                    # ACK 
            
            'get2kernelinfo',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo',         # ACK 5.7.3  p164  
            'get2kernelarginfo',               # ACK 5.7.3  p166                                  
            
            'release2kernel',                  # ACK 5.7.1  p159                                         
            'retain2kernel',                   # ACK 5.7.1  p159   
 
            'set2kernel',                      # ACK 
            'set2kernelcallback',              # ACK 
            'set2kernelarg',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel',                    # ACK 
            
            'sense',                           # ACK
            'reason',                          # ACK
            'ace')                             # ACK   
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-RPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 110A/700) OF RPU2KERNEL4XI5TEST - CREATING KERNEL OBJECT OF RPU ', time4xi())        
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                  
    #       # ---------------------------------------------------------------------------------------------        
    #       kernelobject2rpu = RPU2Kernel4Xi()
    #       print('(Step 110B/700) OF RPU2KERNEL4XI5TEST - CREATED KERNEL OBJECT OF RPU: ', kernelobject2rpu)                                  
    #       # 
    #   except:
    #       print('(Step 110Z/700) OF RPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL OBJECT OF RPU') 
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4kernel2rpu = None):
        '''
        _init__ method initializes RPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "RPU2Kernel4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-RPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        message2print = "{(Step 1B/33) borning" + "; rpu2kernel2xi-of-RPU2Kernel4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-rpu2kernel2xi-of-RPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2rpu-sharing-by-rpu2kernel2xi-of-RPU2Kernel4Xi: " + str(RPU2Kernel4Xi.classvariable2rpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4        
                                
        message2print = "{(Step 1E/33) passed" + "; task4kernel2rpu-passed-to-init-of-RPU2Kernel4Xi: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                      
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
    
        message2print = "{(Step 2A/33) passing" + "; task4kernel2rpu-passing-to-create2kernel4rpu-by-init-of-RPU2Kernel4Xi: " + str(task4kernel2rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
                
        rpu2kernel2xi = create2kernel4rpu(task4kernel2rpu)
        
        message2print = "{(Step 2B/33) performed" + "; create2kernel4rpu-performed-by-init-of-RPU2Kernel4Xi: " + str(create2kernel4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2kernel4rpu at 0x00000000041E54C8>
       
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; rpu2kernel2xi-of-RPU2Kernel4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-rpu2kernel2xi-of-RPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2rpu-shared-by-rpu2kernel2xi-of-RPU2Kernel4Xi: " + str(RPU2Kernel4Xi.classvariable2rpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #     
       
        message2print = "{(Step 3D/33) returning" + "; init-of-RPU2Kernel4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "add2kernel-of-RPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 132A/700) OF RPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL TO RPU  WITH METHOD', time4xi())         
    #   try:
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4rpu + 'rpu2dummy4xi.py'] = {}
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4rpu + 'rpu2dummy4xi.py'] [1] = '... profile = "11" />'
    #
    #       response4add2kernel = programobject2rpu.add2kernel(task4add2kernel) 
    #       print('(Step 132B/700) OF RPU2KERNEL4XI5TEST - ADDED KERNEL TO RPU  WITH METHOD', time4xi())
    #   except:
    #       print('(Step 132Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO ADD KERNEL TO RPU WITH METHOD *** ', time4xi())
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def add2kernel(self, task4add2kernel = None):
        '''
        adds kernel to RPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "add2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; add2kernel-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4add2kernel-passed-to-add2kernel-of-RPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4add2kernel-passing-to-add2kernel4rpu-by-add2kernel-of-RPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4add2kernel = add2kernel4rpu(task4add2kernel)

        message2print = "{(Step 2B/33) performed" + "; add2kernel4rpu-performed-by-add2kernel-of-RPU2Kernel4Xi: " + str(add2kernel4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4add2kernel-returning-by-add2kernel-of-RPU2Kernel4Xi: " + str(response4add2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4add2kernel
                                
                            
    #</methodize4xi>    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2task-of-RPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 240A/700) OF RPU2KERNEL4XI5TEST - TRYING TO EXECUTE TASK OF RPU WITH METHOD ', time4xi())    
    #   try:                               
    #       response4execute2task = programobject2rpu.execute2task() 
    #       print('(Step 240B/700) OF RPU2KERNEL4XI5TEST - EXECUTED TASK OF RPU WITH METHOD ', time4xi())
    #   except:
    #       print('(Step 240Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO EXECUTE TASK OF RPU WITH METHOD ', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2task(self, task4execute = None):
        '''
        executes task of kernel of RPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "execute2task"
                     
        message2print = "{(Step 1A/33) started" + "; execute2task-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute-passed-to-create-of-RPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute-passing-to-execute2task4rpu-by-execute2task-of-RPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        rpu2program2xi = execute2task4rpu(task4execute)

        message2print = "{(Step 2B/33) performed" + "; execute2task4rpu-performed-by-execute2task-of-RPU2Kernel4Xi: " + str(execute2task4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; rpu2program2xi-returning-by-execute2task-of-RPU2Kernel4Xi: " + str(rpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return rpu2program2xi
                     
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2nativekernel-of-RPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121A1/700) OF RPU2KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL OF RPU ', time4xi())      
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # COMPILE                        
    #       # ---------------------------------------------------------------------------------------------        
    #       response4compile = executeobject2rpu.execute2nativekernel()
    #       print('(Step 121A2/700) OF RPU2KERNEL4XI5TEST - EXECUTED KERNEL OF RPU', time4xi())                                   
    #   except:
    #       print('(Step 121AZ1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL OF RPU', time4xi())   
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2nativekernel(self, task4execute2kernel = None):
        '''
        executes native kernel of RPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "execute2nativekernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2nativekernel-of-RPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-create-of-RPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2nativekernel4rpu-by-execute2nativekernel-of-RPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        rpu2execute2xi = execute2nativekernel4rpu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2nativekernel4rpu-performed-by-execute2nativekernel-of-RPU2Kernel4Xi: " + str(execute2nativekernel4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; rpu2execute2xi-returning-by-execute2nativekernel-of-RPU2Kernel4Xi: " + str(rpu2execute2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return rpu2execute2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelworkgroupinfo-of-RPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121C1/700) OF RPU2KERNEL4XI5TEST - TRYING TO GET WORK GROUP INFOR OF RPU WITH METHOD ', time4xi())      
    #   try:
    #      
    #       response4getworkgroupinfo = programobject2rpu.get2kernelworkgroupinfo()
    #       print('(Step 121C2/700) OF RPU2KERNEL4XI5TEST - GOT WORK GROUP INFOR OF RPU WITH METHOD ', time4xi())                                   
    #   except:
    #       print('(Step 121CZ1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO GET WORK GROUP INFOR OF RPU WITH METHOD ', time4xi())  
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelworkgroupinfo(self, task4getworkgroupinfo = None):
        '''
        get kernel work group info OF RPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "get2kernelworkgroupinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelworkgroupinfo-of-RPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4getworkgroupinfo-passed-to-create-of-RPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4getworkgroupinfo-passing-to-get2kernelworkgroupinfo4rpu-by-get2kernelworkgroupinfo-of-RPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        rpu2program2xi = get2kernelworkgroupinfo4rpu(task4getworkgroupinfo)

        message2print = "{(Step 2B/33) performed" + "; get2kernelworkgroupinfo4rpu-performed-by-get2kernelworkgroupinfo-of-RPU2Kernel4Xi: " + str(get2kernelworkgroupinfo4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; rpu2program2xi-returning-by-get2kernelworkgroupinfo-of-RPU2Kernel4Xi: " + str(rpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return rpu2program2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernel-of-RPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 190A/700) OF RPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR RPU ', time4xi()) 
    #   try:
    #       kernelobject2rpu = RPU2Kernel4Xi()                            
    #       response4create2kernel = kernelobject2rpu.create2kernel()
    #       print('(Step 190B/700) OF RPU2KERNEL4XI5TEST - CREATED KERNEL FOR RPU ', time4xi())
    #   except:
    #       print('(Step 190Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR RPU ', time4xi())                                    
    #           
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernel(self, task4kernel2create = None):
        '''
        create2kernel method creates kernel objects of RPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "create2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernel-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-RPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernel4rpu-by-create2kernel-of-RPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #  
  
        rpu2kernel2xi = create2kernel4rpu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernel4rpu-performed-by-create2kernel-of-RPU2Kernel4Xi: " + str(create2kernel4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernel4rpu at 0x0000000003B0C5C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        keys2response4create = rpu2kernel2xi.keys() 
        message2print = "{(Step 33A/33) returning" + "; keys2response4create-returning-by-create2kernel-of-RPU2Kernel4Xi: " + str(keys2response4create) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # ['FUNCTION',
        #  'CODE2ERROR',
        #  'COUNT2REFERENCE',
        #  'DATA2CALLBACK',
        #  'BUFFER',
        #  'FUNCTION2CALLBACK',
        #  'ACK2RETURN',
        #  'QUEUE',
        #  'PLATFORM',
        #  'PROGRAM',
        #  'NACK2RETURN',
        #  'CONTEXT',
        #  'COMMANDQUEUE',
        #  'DEVICE',
        #  'EVENT',
        #  'PIPE']
        message2print = "{(Step 33B/33) returning" + "; function-returning-by-create2kernel-of-RPU2Kernel4Xi: " + str(rpu2kernel2xi['FUNCTION']) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # rpu2sampler4xi5test 
        
        return rpu2kernel2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernelsinprogram-of-RPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 130A/700) OF RPU2KERNEL4XI5TEST - CREATING KERNELS IN PROGRM FOR RPU ', time4xi())      
    #   try:
    #       response4create2kernelsinprogram = kernelobject2rpu.create2kernelsinprogram()
    #       print('(Step 130A/700) OF RPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRM FOR RPU ', time4xi())
    #   except:
    #       print('(Step 130Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO KERNELS IN PROGRM FOR RPU', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernelsinprogram(self, task4kernel2create = None):
        '''
        creates kernels in program of RPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "create2kernelsinprogram"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernelsinprogram-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-RPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernelsinprogram4rpu-by-create2kernelsinprogram-of-RPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        rpu2kernel2xi = create2kernelsinprogram4rpu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernelsinprogram4rpu-performed-by-create2kernelsinprogram-of-RPU2Kernel4Xi: " + str(create2kernelsinprogram4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernelsinprogram4rpu at 0x00000000040248C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; rpu2kernel2xi-returning-by-create2kernelsinprogram-of-RPU2Kernel4Xi: " + str(rpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return rpu2kernel2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delete2kernel-of-RPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 134A/700) OF RPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL IN PROGRAM OF RPU WITH METHOD ', time4xi())        
    #   try:
    #       task4delete2kernel = {}
    #       task4delete2kernel ['CODE4KERNEL'] = {}
    #       task4delete2kernel ['CODE4KERNEL'] [folder2lib4rpu + 'dummy3image4xi..py'] = 'Yes'
    #       task4delete2kernel ['SIZE4KERNEL'] = {}
    #       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4rpu + 'dummy3image4xi..py'] = 'Yes'
    #       
    #       response4delete2kernel = programobject2rpu.delete2kernel(task4delete2kernel)
    #       print('(Step 134B/700) OF RPU2KERNEL4XI5TEST - DELETED DELETE KERNEL IN PROGRAM of RPUWITH METHOD ', time4xi())                                                                  
    #   except:
    #       print('(Step 134Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO DELETE DELETE KERNEL IN PROGRAM OF RPU WITH METHOD *** ', time4xi())
    #                  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def delete2kernel(self, task4delete2kernel = None):
        '''
        deletes kernel in program of RPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "delete2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; delete2kernel-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4delete2kernel-passed-to-delete2kernel-of-RPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4delete2kernel-passing-to-delete2kernel4rpu-by-delete2kernel-of-RPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4delete2kernel = delete2kernel4rpu(task4delete2kernel)

        message2print = "{(Step 2B/33) performed" + "; delete2kernel4rpu-performed-by-delete2kernel-of-RPU2Kernel4Xi: " + str(delete2kernel4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4delete2kernel-returning-by-delete2kernel-of-RPU2Kernel4Xi: " + str(response4delete2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4delete2kernel
                                
                            
    #</methodize4xi>    


        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernel-of-RPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernel ...
    #   print('(Step 158A/700) OF RPU2KERNEL4XI5TEST - TRYING TO SET KERNEL OF RPU: ', time4xi()) 
    #   try: 
    #       response4set2kernel = kernelobject2rpu.set2kernel(task4set2kernel)
    #       print('(Step 158B/700) OF RPU2KERNEL4XI5TEST - SET KERNEL OF RPU: ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL OF RPU: ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernel(self, task4set2kernel = None):
        '''
        sets kernel RPU objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "set2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernel-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernel-passed-to-set2kernel-of-RPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernel-passing-to-set2kernel4rpu-by-set2kernel-of-RPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        rpu2kernel2xi = set2kernel4rpu(task4set2kernel)

        message2print = "{(Step 2B/33) performed" + "; set2kernel4rpu-performed-by-set2kernel-of-RPU2Kernel4Xi: " + str(set2kernel4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; rpu2kernel2xi-returning-by-set2kernel-of-RPU2Kernel4Xi: " + str(rpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return rpu2kernel2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelarg-of-RPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernelarg ...
    #   print('(Step 158A/700) OF RPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS FOR RPU: ', time4xi())
    #   try: 
    #       response4set2kernelarg = programobject2rpu.set2kernelarg(task4set2kernelarg)
    #       print('(Step 158B/700) OF RPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS FOR RPU ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS FOR RPU ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelarg(self, task4set2kernelarg = None):
        '''
        sets kernel arguments for RPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "set2kernelarg"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelarg-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelarg-passed-to-set2kernelarg-of-RPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelarg-passing-to-set2kernelarg4rpu-by-set2kernelarg-of-RPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        rpu2program2xi = set2kernelarg4rpu(task4set2kernelarg)

        message2print = "{(Step 2B/33) performed" + "; set2kernelarg4rpu-performed-by-set2kernelarg-of-RPU2Kernel4Xi: " + str(set2kernelarg4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; rpu2program2xi-returning-by-set2kernelarg-of-RPU2Kernel4Xi: " + str(rpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return rpu2program2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelinfo-of-RPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF RPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFO ', time4xi())    
    #   try:                               
    #       response4get2kernelinfo = kernelobject2rpu.get2kernelinfo()                                 
    #       print('(Step 106B/700) OF RPU2KERNEL4XI5TEST - GOT GET KERNEL INFO ', time4xi())                             
    #   except:
    #       print('(Step 106Z/700) OF RPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO ', time4xi()) 
    #   
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelinfo(self, task4getinfo2kernel=None):
        '''
        gets kernel info of RPU 
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "get2kernelinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelinfo-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        rpu2kernel2xi = get2kernelinfo4rpu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; rpu2kernel2xi-returning-by-get2kernelinfo-of-RPU2Kernel4Xi: " + str(rpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return rpu2kernel2xi
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelarginfo-of-RPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF RPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENT INFO OF RPU ', time4xi())    
    #   try:                               
    #       response4get2kernelarginfo = kernelobject2rpu.get2kernelarginfo()
    #       print('(Step 106B/700) OF RPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENT INFO OF RPU ', time4xi())                                   
    #   except:
    #       print('(Step 106Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENT INFO OF RPU ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelarginfo(self, task4getinfo2kernel=None):
        '''
        gets kernel argument info of RPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "get2kernelarginfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelarginfo-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:01:22 11/17/11 Pacific Standard Time

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        rpu2kernel2xi = get2kernelarginfo4rpu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; rpu2kernel2xi-returning-by-get2kernelarginfo-of-RPU2Kernel4Xi: " + str(rpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return rpu2kernel2xi
                            
    #</methodize4xi>
   
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2buildinfo-of-RPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A1/700) OF RPU2BUILD4XI5TEST - TRYING TO GET BUILD INFO ', time4xi())    
    #   try:                               
    #                               
    #       response4get2buildinfo = programobject2rpu.get2buildinfo()
    #       print('(Step 106A2/700) OF RPU2BUILD4XI5TEST - GOT BUILD INFO ', time4xi())    
    #   except:
    #       print('(Step 106Z1/700) OF RPU2BUILD4XI5TEST *** FAILED TO GET BUILD INFO ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2buildinfo(self, task4getinfo2build=None):
        '''
        get2buildinfo method gets objects of RPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "get2buildinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2buildinfo-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        rpu2build2xi = get2buildinfo4rpu(task4getinfo2build)
        
        message2print = "{(Step 2A/33) returning" + "; rpu2build2xi-returning-by-get2buildinfo-of-RPU2Kernel4Xi: " + str(rpu2build2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        return rpu2build2xi
                            
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2kernel-of-RPU2Kernel4Xi" usage = "
    #
    #   print('(Step 170A/700) OF RPU2KERNEL4XI5TEST - RELEASING KERNEL ', time4xi())  
    #   task4release2kernel  = {}
    #   task4release2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4release2kernel = kernelobject2rpu.release2kernel(task4release2kernel)
    #       print('(Step 170B/700) OF RPU2KERNEL4XI5TEST - RELEASED KERNEL ', time4xi())
    #   except:
    #       print('(Step 170Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL ', time4xi())                        
    #       keys2response = response4release2kernel.keys()
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2kernel(self, task4release2kernel = None):
        '''
        releases RPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "release2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; release2kernel-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2kernel-passed-to-release2kernel-of-RPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2kernel-passing-to-release2kernel4rpu-by-release2kernel-of-RPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        rpu2kernel2xi = release2kernel4rpu(task4release2kernel)

        message2print = "{(Step 2B/33) performed" + "; release2kernel4rpu-performed-by-release2kernel-of-RPU2Kernel4Xi: " + str(release2kernel4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; rpu2kernel2xi-returning-by-release2kernel-of-RPU2Kernel4Xi: " + str(rpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #               
                
        return rpu2kernel2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2kernel-of-RPU2Kernel4Xi" usage = "
    #
    #   print('(Step 180A/700) OF RPU2KERNEL4XI5TEST - RETAINING KERNEL ', time4xi())
    #   task4retain2kernel  = {}
    #   task4retain2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4retain2kernel = kernelobject2rpu.retain2kernel(task4retain2kernel)
    #       print('(Step 180B/700) OF RPU2KERNEL4XI5TEST - RETAINED KERNEL ', time4xi())
    #   except:
    #       print('(Step 180Z1/700) OF RPU2KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL ', time4xi())                    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2kernel(self, task4retain2kernel = None):
        '''
        retains RPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "retain2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; retain2kernel-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2kernel-of-RPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2kernel4rpu-by-retain-of-RPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
  
        rpu2kernel2xi = retain2kernel4rpu(task4retain2kernel)

        message2print = "{(Step 2B/33) performed" + "; retain2kernel4rpu-performed-by-retain2kernel-of-RPU2Kernel4Xi: " + str(retain2kernel4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; rpu2kernel2xi-returning-by-retain2kernel-of-RPU2Kernel4Xi: " + str(rpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
            
                
        return rpu2kernel2xi
                                                           
    #</methodize4xi>   
    
 
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2kernel-of-RPU2Kernel4Xi" usage = "
    #     
    #   print('(Step 210A/25) OF RPU2KERNEL4XI5TEST - TRYING TO TRACE RPU: ', time4xi())      
    #   trace2rpu = None
    #   try:
    #       trace2rpu = programobject2rpu.trace2kernel() 
    #               print('(Step 210B/25) OF RPU2KERNEL4XI5TEST - TRACE2RPU: ', trace2rpu)  
    #       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4rpu-failed {}; time: 04:40:24 11/16/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4rpu', 'METHOD': 'trace2kernel4rpu'}
    #        except:
    #           print('(Step 210Z1/25) OF RPU2KERNEL4XI5TEST *** FAILED TO TRACE RPU: ', trace2rpu) 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2kernel(self, task4trace2kernel = None):
        '''
        traces RPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "trace2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; trace2kernel-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2kernel-passed-to-trace-of-RPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2kernel-passing-to-trace2kernel4rpu-by-trace2kernel-of-RPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = trace2kernel4rpu(task4trace2kernel)

        message2print = "{(Step 2B/33) performed" + "; trace2kernel4rpu-performed-by-trace2kernel-of-RPU2Kernel4Xi: " + str(trace2kernel4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2kernel-of-RPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2kernel-of-RPU2Kernel4Xi" usage = "
    #        
    #   print('(Step 220A/25) OF RPU2KERNEL4XI5TEST - TRYING TO UNLOAD COMPILER OF RPU: ', time4xi())      
    #   try:
    #       response4execute2kernel = programobject2rpu.execute2kernel() 
    #       print('(Step 220B/25) OF RPU2KERNEL4XI5TEST - UNLOADED COMPILER OF RPU: ', response4execute2kernel)  
    #       # 
    #   except:
    #       print('(Step 220Z1/25) OF RPU2KERNEL4XI5TEST *** FAILED TO TO UNLOAD COMPILER OF RPU: ', time4xi()) 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def execute2kernel(self, task4execute2kernel = None):
        '''
        executes kernel
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "execute2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2kernel-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-trace-of-RPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2kernel4rpu-by-execute2kernel-of-RPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = execute2kernel4rpu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2kernel4rpu-performed-by-execute2kernel-of-RPU2Kernel4Xi: " + str(execute2kernel4rpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-execute2kernel-of-RPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelcallback-of-RPU2Kernel4Xi" usage = "
    #
    #   print('(Step 200A/700) OF RPU2KERNEL4XI5TEST - TRYING TO SET KERNELCALLBACK WITH METHOD OF OBJECT XI2RPU: ', programobject2rpu) 
    #   try:
    #       callback2rpu = programobject2rpu.set2kernelcallback()                                  
    #       print('(Step 200B/700) OF RPU2KERNEL4XI5TEST - SET KERNELWITH CALLBACK TO: ', callback2rpu)
    #       # 
    #   except:
    #       print('(Step 200Z/700) OF RPU2KERNEL4XI5TEST *** FAILED TO SET KERNELCALLBACK WITH METHOD ***', time4xi())
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelcallback(self, task4set2kernelcallback = None): 
        '''
        set2kernelcallback of RPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "RPU2Kernel4Xi"
        method2print = "set2kernelcallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelcallback-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelcallback-passed-to-set2kernelcallback-of-RPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelcallback-passing-to-set2kernelcallback-by-set2kernelcallback-of-RPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        
        callback2rpu4program = {} 
        try:
            callback2rpu4program = set2kernelcallback4rpu (task4set2kernelcallback)

            
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2rpu4program-failed-by-set2kernelcallback-of-RPU2Kernel4Xi: " + str(callback2rpu4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2rpu4program-returning-by-set2kernelcallback-of-RPU2Kernel4Xi: " + str(callback2rpu4program) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # <function trace2kernel4rpu at 0x00000000038CF5C8> 
        
                                             
        return callback2rpu4program
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-RPU2Kernel4Xi" usage = "
    #
    #   print('(Step 310A/700) OF RPU2KERNEL4XI5TEST - SENSING ', time4xi())  
    #   try:
    #       print(programobject2rpu.sense())
    #       print('(Step 310B/700) OF RPU2KERNEL4XI5TEST - SENSED ', time4xi()) 
    #       # 
    #   except:
    #       print('(Step 310Z/700) OF RPU2KERNEL4XI5TEST *** FAILED TO SENSE ', time4xi())     
    #
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses RPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'RPU2Kernel4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; RPU2Kernel4Xi-sensing-by-sense-of-RPU2Kernel4Xi: " + str(RPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
            
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-RPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2rpu-of-RPU2Kernel4Xi'] = RPU2Kernel4Xi.classvariable2rpu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-RPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; RPU2Kernel4Xi-sensed-by-sense-of-RPU2Kernel4Xi: " + str(RPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-RPU2Kernel4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-RPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 320A/700) OF RPU2KERNEL4XI5TEST - REASONING ', time4xi())
    #   try:
    #       print(programobject2rpu.reason())
    #       print('(Step 320B/700) OF RPU2KERNEL4XI5TEST - REASONED ', time4xi())
    #       # 
    #   except:
    #       print('(Step 320Z/700) OF RPU2KERNEL4XI5TEST *** FAILED TO REASON ', time4xi()) 
    #
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons RPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'RPU2Kernel4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; RPU2Kernel4Xi-reasoning-by-reason-of-RPU2Kernel4Xi: " + str(RPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-RPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
             
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-RPU2Kernel4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-RPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; RPU2Kernel4Xi-reasoned-by-reason-of-RPU2Kernel4Xi: " + str(RPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-RPU2Kernel4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #           
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-RPU2Kernel4Xi" usage = "
    #
    #   print('(Step 330A/700) OF RPU2KERNEL4XI5TEST - ACING ', time4xi())   
    #   try:
    #       print(programobject2rpu.ace())
    #       print('(Step 330B/700) OF RPU2KERNEL4XI5TEST - ACED ', time4xi())                                                 
    #       # 
    #   except:
    #       print('(Step 330Z/700) OF RPU2KERNEL4XI5TEST *** FAILED TO ACE ', time4xi())                                 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces RPU2Kernel4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'RPU2Kernel4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-RPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; RPU2Kernel4Xi-acing-by-ace-of-RPU2Kernel4Xi: " + str(RPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #      
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-RPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-RPU2Kernel4Xi'] = RPU2Kernel4Xi.classvariable2rpu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-RPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; RPU2Kernel4Xi-aced-by-ace-of-RPU2Kernel4Xi: " + str(RPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'rpu2codeprogram4xi.RPU2Kernel4Xi'> 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-RPU2Kernel4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
#</class4xi>

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   rpu2codeprogram4xi5test.txt
#   sense-rpu2codeprogram4xi5test.xml
#   reason-rpu2codeprogram4xi5test.xml
#   ace-rpu2codeprogram4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of rpu2kernel4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
